      subroutine fgmap
c
c   sets up maps (ignum1&2) for grids that specifies which cell is to
c   be used in each cell to get the value.  0 means coarse
c   grid, other values correspond to fine grid number.
c   (tcm, 1/14/93)
c
      include 'xtract.inc'
      include 'xtract2.inc'
c
c   if coarse grid is used, initialize entire grid to zeros, 
c   implying all coarse grid, otherwise initialize to first fine
c   grid
c
      ncrs = id(0,lgrd,ngrd)
      if (ncrs .ge. 0) then
        iset = 0
      else
        iset = lgrd(1)
      endif
      do 50 j=1,nyi
        do 40 i=1,nxi
          ignum1(i,j) = iset
          ignum2(i,j) = iset
   40   continue
   50 continue
c
c   loop over all file 1 fine grids and flag appropriate cells
c   for each fine grid.  Note that since fine grids that are within
c   fine grids always come after the fine grid that they are within,
c   we can just overlay previous values that have been filled in.
c
c   if coarse grid is being used . . .
      if (ncrs .ge. 0) then
        do 130 ifine=1,numfin1
          nn = id(ifine,lgrd,ngrd)
c
          if (nn .gt. 0) then 
c
c   recalculate start and end cells in terms of new resolution
c
            ixg1 = (ixfb1(ifine)-1)*nhmax + 1
            ixg2 = ixfe1(ifine)*nhmax
            jyg1 = (jyfb1(ifine)-1)*nhmax + 1
            jyg2 = jyfe1(ifine)*nhmax
c
c   set cells to this fine grid number
c
            do 120 j=jyg1,jyg2
              do 110 i=ixg1,ixg2
                ignum1(i,j) = ifine
  110         continue
  120       continue
c
          endif
c
  130   continue
c
c   . . . but if no coarse grid we must reference to first fine grid
      else
        iref1 = ixfb1(lgrd(1))
        jref1 = jyfb1(lgrd(1))
        nhlast = nhmax*nhf1(lgrd(1))
        do 170 ifine=1,numfin1
          if (ifine .eq. lgrd(1)) go to 170
          nn = id(ifine,lgrd,ngrd)
c
          if (nn .gt. 0) then 
c
c   recalculate start and end cells in terms of new resolution
c
            ixg1 = ((ixfb1(ifine)-iref1)*nhf1(lgrd(1))+1)*nhmax + 1
            ixg2 = ixg1 + (nfx1(ifine)-2)*nhlast/nhf1(ifine) - 1
            jyg1 = ((jyfb1(ifine)-jref1)*nhf1(lgrd(1))+1)*nhmax + 1
            jyg2 = jyg1 + (nfy1(ifine)-2)*nhlast/nhf1(ifine) - 1
c
c   set cells to this fine grid number
c
            do 150 j=jyg1,jyg2
              do 140 i=ixg1,ixg2
                ignum1(i,j) = ifine
  140         continue
  150       continue
c
          endif
c
  170   continue
      endif
c
c  temporary write to check things out
c
c     write(*,*) 'ignum1:'
c     do 200 j=nyi,1,-1
c       write(*,'(130i1)') (ignum1(i,j),i=1,nxi)
c 200 continue
c
c   loop over all file 2 fine grids and flag appropriate cells
c   for each fine grid.  Note that since fine grids that are within
c   fine grids always come after the fine grid that they are within,
c   we can just overlay previous values that have been filled in.
c
c
c   if coarse grid is being used . . .
      if (ncrs .ge. 0) then
        do 230 ifine=1,numfin2
          nn = id(ifine,lgrd,ngrd)
c
          if (nn .gt. 0) then 
c
c   recalculate start and end cells in terms of new resolution
c
            ixg1 = (ixfb2(ifine)-1)*nhmax + 1
            ixg2 = ixfe2(ifine)*nhmax
            jyg1 = (jyfb2(ifine)-1)*nhmax + 1
            jyg2 = jyfe2(ifine)*nhmax
c
c   set cells to this fine grid number
c
            do 220 j=jyg1,jyg2
              do 210 i=ixg1,ixg2
                ignum2(i,j) = ifine
  210         continue
  220       continue
c
          endif
c
  230   continue
c
c   . . . but if no coarse grid we must reference to first fine grid
      else
        iref2 = ixfb2(lgrd(1))
        jref2 = jyfb2(lgrd(1))
        nhlast = nhmax*nhf2(lgrd(1))
        do 270 ifine=1,numfin2
          if (ifine .eq. lgrd(1)) go to 270
          nn = id(ifine,lgrd,ngrd)
c
          if (nn .gt. 0) then 
c
c   recalculate start and end cells in terms of new resolution
c
            ixg1 = ((ixfb2(ifine)-iref2)*nhf2(lgrd(1))+1)*nhmax + 1
            ixg2 = ixg1 + (nfx2(ifine)-2)*nhlast/nhf2(ifine) - 1
            jyg1 = ((jyfb2(ifine)-jref2)*nhf2(lgrd(1))+1)*nhmax + 1
            jyg2 = jyg1 + (nfy2(ifine)-2)*nhlast/nhf2(ifine) - 1
c
c   set cells to this fine grid number
c
            do 250 j=jyg1,jyg2
              do 240 i=ixg1,ixg2
                ignum2(i,j) = ifine
  240         continue
  250       continue
c
          endif
c
  270   continue
      endif
c
      return
      end
