c--------------------------------------------------------------------c
c          ATDM POSTPROCESSING PACKAGE:   EXTRACT                    c
c          11/1/95  CAE                                              c
c--------------------------------------------------------------------c
c
c     READS FINE GRID CONCENTRATION FILE
c
      SUBROUTINE GETZF(ierr,deltat)
      include 'xtract.inc'
      include 'xtract2.inc'
c     include 'xfer.inc'
      real CNCR(MXX,MXY)
      real CONC(MXX,MXY)
      real tmpdep1(mxx,mxy),tmpdep2(mxx,mxy)
      logical lkeep
C
C... CONC   - A LOCAL 2-D BUFFER ARRAY
C    CNC1   - A GLOBAL CONCENTRATION ARRAY FOR FILE-ONE CONCENTRATIONS
C    CNC2   - "     "      "         "   "  "  FILE-TWO      "
c
c  find ratio of finest grid in use to coarse grid
c
      nhfnst = 1
      write (*,*) 'before 30'
      do 30 ifine=1,numfin1
c         write (*,*) 'ifine, numfin1, ngrd, lgrd', 
c     &                ifine,numfin1,ngrd,lgrd
        NN = ID(IFINE,LGRD,NGRD)
        write(*,*) 'nn: ', nn
        write(*,*) 'nhf1: ', nhf1
        if (nn .gt. 0) nhfnst = max(nhfnst,nhf1(lgrd(nn)))
   30 continue
c
      write (*,*) 'after 30'
   23 READ(ICNC1F,END=999)  ENDTIM, IEDAT
      ENDTIM=AINT(ENDTIM/100.+0.01)
      IF (IEDAT .GT. 99999) THEN 
        CALL CALTOJ(IEDAT,IDNEW)
        IEDAT = IDNEW
      ENDIF
      WRITE(*,1005) ENDTIM, IEDAT
      IF (LINST) THEN
        BEGTIM = ENDTIM
      ELSE
c       BEGTIM = ENDTIM - 1.
        BEGTIM = ENDTIM - deltat
      ENDIF
      write(*,*) 'linst,begtim,endtim,deltat:',linst,
     &                             begtim,endtim,deltat
      IBDAT = IEDAT
      if (begtim .lt. 0.) then
        begtim = begtim + 24.
        ibdat = ibdat - 1
      endif
      lkeep = .true.
      tchk = begtim + 24.*(ibdat-idat1)
      if (tchk .lt. tim1) then
        write(*,*) ' (skipped)'
        lkeep = .false.
      endif
      if ( lconv ) call gtvlvl(0)
C
      IERR = 0
      LL = 0
      KK = 0
      NN = 0
      MM = 1
c
c   if ncrs is less than zero, the coarse grid is not being
c   included in the plot.  In that case, the first nested grid
c   specified in lgrd will be taken to be the base grid
c
      NCRS = ID(0,LGRD,NGRD)
C
      write (*,*) 'before 410'
      DO 410 IFINE = 1,NUMFIN1
      do i=1,mxx
	do j=1,mxy
	  cncr(i,j)=0.0
	  conc(i,j)=0.0
	enddo
      enddo
      NN = ID(IFINE,LGRD,NGRD)
      if ( nfz1(ifine) .ne. 1 .and. .not. linst ) nfz1(ifine)=1
C
      DO 400 ISPEC=1,NOSPEC1
C
C    LOOP OVER NUMBER OF VERTICAL LEVELS IN SIMULATION GRID
C
         if (lsum) then
           ll = id(ispec,lsub,nsub)
         else
           LL = ID(ISPEC,LVAR1,NVAR)
         endif
c
         if (ll.gt.0) then
           write(*,*)'PROCESSING SPECIES # ',mm,ll,ispec
           if (lsum) then
             fact=cvt(iunit(mm))*xfact(ISPEC,1)*subfac(ll)
           else
             fact=cvt(iunit(ll))*xfact(ISPEC,1)
           endif
 	   lll=ident(mspec1(1,ispec),mspint,nspint)
         endif
c
         iout = nfx1(ifine)/2
         jout = nfy1(ifine)/2
c
         DO 401 IZ=1,NFZ1(IFINE)
c
            KK = ID(IZ,LEVEL,NLVL)
c
            if (ldepn .and. ifrst) then
              read (icnc1f)((tmpdep1(i,j),i=1,nfx1(ifine)),
     &                                  j=1,nfy1(ifine))
              read (icnc1f)((tmpdep2(i,j),i=1,nfx1(ifine)),
     &                                  j=1,nfy1(ifine))
              write(*,*) 'ifine, nfx1(ifine), nfy1(ifine): '
              write(*,*) ifine, nfx1(ifine), nfy1(ifine)
              write(*,*) 'ispec, iout, jout, tmpdep1: '
              write(*,*) ispec, iout, jout, tmpdep1(iout,jout)
              if (ll.le.0 .or. kk.le.0 .or. .not.lkeep .or.
     &            nn.le.0) go to 401
              if (ndepn.eq.'DRY ') then
                do 402 j = 1,nfy1(ifine)
                  do 402 i = 1,nfx1(ifine)
                    cncr(i,j) = tmpdep1(i,j)
  402           continue
              elseif (ndepn.eq.'WET ') then
                do 403 j = 1,nfy1(ifine)
                  do 403 i = 1,nfx1(ifine)
                    cncr(i,j) = tmpdep2(i,j)
c                   if (cncr(i,j).ne.0.) write(*,*)i,j,cncr(i,j)
  403           continue
              else
                do 404 j = 1,nfy1(ifine)
                  do 404 i = 1,nfx1(ifine)
                    cncr(i,j) = tmpdep1(i,j) + tmpdep2(i,j)
  404           continue
              endif
              write(*,*) 'after 404, ispec, iout, jout, cncr: '
              write(*,*) ispec, iout, jout, cncr(iout,jout)
             write(*,*)'ll,kk,lkeep,nn',ll,kk,lkeep,nn
             write(*,*)'dry: ',tmpdep1(75,30)
             write(*,*)'wet: ',tmpdep2(75,30)
             write(*,*)'cncr: ',cncr(75,30)
            else
              READ (ICNC1F) ((CNCR(I,J),
     &                      I=1,NFX1(IFINE)),J=1,NFY1(IFINE))
              if (ll.le.0 .or. kk.le.0 .or. .not.lkeep .or.
     &            nn.le.0) go to 401
	      if ( lconv ) then
c		if ( nfz1(ifine) .ne. nz .and. ngrd. eq. 1 ) then
c		if ( ngrd. eq. 1 ) then
c		   call conppm(nxrd,nyrd,iz,lll,cncr)
c		else
		   call cnfppm(ifine,nfx1(ifine),nfy1(ifine),iz,
     &                                                 lll,cncr)
		   write(*,*) 'cncr :',cncr(75,30)
c		endif
	      endif
            endif
c
             if (ncrs .ge. 0) then
               nhh = nhmax/nhf1(ifine)
               if (nhh .gt. 1) then
                 call grdgro(cncr,mxx,nfx1(ifine),nfy1(ifine),
     $                          nhh,mxx,conc)
               else
c                write(*,*)'fine grid, assigning conc'
                 do 375 j=1,nfy1(ifine)
                   do 375 i=1,nfx1(ifine)
                     conc(i,j) = cncr(i,j)
                    if (i.eq.75.and.j.eq.30) write(*,*)cncr(i,j)
  375            continue
               endif
               irel = (ixfb1(ifine)-1)*nhmax - nhh
               jrel = (jyfb1(ifine)-1)*nhmax - nhh
c              write(*,*)irel,jrel
             else if (ngrd .eq. 1) then 
               nhh = 1
c               write(*,*)'only grid, assigning conc'
               do 380 j=1,nfy1(ifine)
                 do 380 i=1,nfx1(ifine)
                   conc(i,j) = cncr(i,j)
                   if (i.eq.75.and.j.eq.30) write(*,*)cncr(i,j)
  380          continue
              write(*,*) 'after 380, ispec, iout, jout, conc: '
              write(*,*) ispec, iout, jout, conc(iout,jout)
               irel = 0
               jrel = 0
c              write(*,*)irel,jrel
             else
               nhh = (nhmax * nhf1(lgrd(1)))/nhf1(ifine)
               if (nhh .gt. 1) then
                 call grdgro(cncr,mxx,nfx1(ifine),nfy1(ifine),
     $                          nhh,mxx,conc)
               else
                 do 385 j=1,nfy1(ifine)
                   do 384 i=1,nfx1(ifine)
                     conc(i,j) = cncr(i,j)
  384              continue
  385            continue
               endif
               irel = (ixfb1(ifine)-ixfb1(lgrd(1)))*nhfnst 
     $                + nhfnst/nhf1(lgrd(1)) - nhfnst/nhf1(ifine)
               jrel = (jyfb1(ifine)-jyfb1(lgrd(1)))*nhfnst
     $                + nhfnst/nhf1(lgrd(1)) - nhfnst/nhf1(ifine)
             endif
c
            DO 600 I = nhh+1,nhh*NFX1(IFINE)-nhh
              DO 600 J = nhh+1,nhh*NFY1(IFINE)-nhh
c                    
c                    if this cell of this fine grid is covered by
c                    another inner fine grid, don't change value in
c                    this cell now.
c
                if (ignum1(i+irel,j+jrel) .ne. ifine) go to 600
c
                IF(LMAX) THEN
                   CNC1(I+irel,J+jrel,LL,KK)=
     &                 AMAX1(FACT*CONC(I,J),CNC1(I+irel,J+jrel,LL,KK))
                ELSE IF(LTOT) THEN
                   CNC1(I+irel,J+jrel,LL,KK)=
     &                 FACT*CONC(I,J) + CNC1(I+irel,J+jrel,LL,KK)
                ELSE IF(LSUM) THEN
                 CNC1(I+irel,J+jrel,MM,KK)=
     &              FACT*CONC(I,J) + CNC1(I+irel,J+jrel,MM,KK)
                ELSE
                   CNC1(I+irel,J+jrel,LL,KK)=FACT*CONC(I,J)
                   if (i.eq.75.and.j.eq.30) 
     &               write(*,*)fact,conc(i,j),i+irel,j+jrel
                ENDIF
 600        CONTINUE
              write(*,*) 'after 600, ispec, iout, jout, cnc1: '
              write(*,*) ispec, iout, jout, cnc1(iout,jout,ll,kk)
c
  401     CONTINUE
  400   CONTINUE
  410 CONTINUE
c
      IF (LDIF) THEN
   25   READ(ICNC2F,END=999)ENDTIM2,IEDAT2
        ENDTIM2=AINT(ENDTIM2/100.+0.01)
        IF (IEDAT2 .GT. 99999) THEN 
          CALL CALTOJ(IEDAT2,IDNEW)
          IEDAT2 = IDNEW
        ENDIF
        WRITE(*,1010) ENDTIM2,IEDAT2
        BEGTIM2 = ENDTIM2 - 1.
        IBDAT2 = IEDAT2
        if (begtim2 .lt. 0.) then
          begtim2 = begtim2 + 24.
          ibdat2 = ibdat2 - 1
        endif
C
        tchk = endtim2 + 24.*(iedat2-iedat)
        IF(tchk.LT.ENDTIM-.01) THEN
          DO 405 IFINE=1,NUMFIN2
	    if ( nfz2(ifine) .ne. 1 .and. .not. linst ) nfz2(ifine)=1
            DO 405 L = 1,NOSPEC2
c             DO 405 K = 1,NZ
              DO 405 K = 1,NFZ2(IFINE)
                READ(ICNC2F)
                if (ldepn .and. ifrst) read(icnc2f)
  405     CONTINUE
          GOTO 25
        ENDIF
        IF(ENDTIM.LT.tchk-.01) THEN
          BACKSPACE(ICNC2F)
          if (ldepn .and. ifrst) backspace(icnc2f)
          GOTO 23
        ENDIF
        lkeep = .true.
        tchk = begtim2 + 24.*(ibdat2-idat1)
        if (tchk .lt. tim1) then
          write(*,*) ' (skipped)'
          lkeep = .false.
        endif
c
c     READ 2ND CONCENTRATION FILE
c
        DO 550 IFINE = 1,NUMFIN2
          do i=1,mxx
    	    do j=1,mxy
	      cncr(i,j)=0.0
	      conc(i,j)=0.0
	    enddo
          enddo
          NN = ID(IFINE,LGRD,NGRD)
	  if ( nfz2(ifine) .ne. 1 .and. .not. linst ) nfz2(ifine)=1
          DO 500 ISPEC=1,NOSPEC2
            LL = ID(ISPEC,LVAR2,NVAR)
 	    lll=ident(mspec1(1,ispec),mspint,nspint)
c
            if(iunit(ll).gt.0)
     &         fact = cvt(iunit(ll)) * xfact(ISPEC,2)
c
            IF(LHC.GT.0.OR.LHCNOX.GT.0) L2=ID(ISPEC,MHC2,NUMHC)
c           DO 501 IZ=1,NZ
            DO 501 IZ=1,NFZ2(IFINE)
              KK = ID(IZ,LEVEL,NLVL)
              if (ldepn .and. ifrst) then
                read (icnc2f)((tmpdep1(i,j),i=1,nfx2(ifine)),
     &                                    j=1,nfy2(ifine))
                read (icnc2f)((tmpdep2(i,j),i=1,nfx2(ifine)),
     &                                    j=1,nfy2(ifine))
                if (ll.le.0 .or. kk.le.0 .or. .not.lkeep .or.
     &              nn.le.0) go to 501
                if (ndepn.eq.'DRY ') then
                  do 4021 j = 1,nfy2(ifine)
                    do 4021 i = 1,nfx2(ifine)
                      cncr(i,j) = tmpdep1(i,j)
 4021             continue
                elseif (ndepn.eq.'WET ') then
                  do 4031 j = 1,nfy2(ifine)
                    do 4031 i = 1,nfx2(ifine)
                      cncr(i,j) = tmpdep2(i,j)
 4031             continue
                else
                  do 4041 j = 1,nfy2(ifine)
                    do 4041 i = 1,nfx2(ifine)
                      cncr(i,j) = tmpdep1(i,j) + tmpdep2(i,j)
 4041             continue
                endif
             else
                READ(ICNC2F) ((CNCR(I,J),
     &                      I=1,NFX2(IFINE)),J=1,NFY2(IFINE))
                if (ll.le.0 .or. kk.le.0 .or. .not.lkeep .or.
     &              nn.le.0) go to 501
	      if ( lconv ) then
		if ( nfz2(ifine) .ne. nz .and. ngrd. eq. 1 ) then
		   call conppm(nxrd,nyrd,iz,lll,cncr)
		else
		   call cnfppm(ifine,nfx2(ifine),nfy2(ifine),iz,
     &                                                 lll,cncr)
		endif
	      endif
             endif
c
                if (ncrs .ge. 0) then
                  nhh = nhmax/nhf2(ifine)
                  call grdgro(cncr,mxx,nfx2(ifine),nfy2(ifine),
     $                          nhh,mxx,conc)
                  irel = (ixfb2(ifine)-1)*nhmax - nhh
                  jrel = (jyfb2(ifine)-1)*nhmax - nhh
                else if (ngrd .eq. 1) then 
                  nhh = 1
                  do 505 j=1,nfy2(ifine)
                    do 505 i=1,nfx2(ifine)
                      conc(i,j) = cncr(i,j)
  505             continue
                  irel = 0
                  jrel = 0
                else
                  nhh = (nhmax * nhf2(lgrd(1)))/nhf2(ifine)
                  if (nhh .gt. 1) then
                    call grdgro(cncr,mxx,nfx2(ifine),nfy2(ifine),
     $                          nhh,mxx,conc)
                  else
                    do 515 j=1,nfy2(ifine)
                      do 514 i=1,nfx2(ifine)
                        conc(i,j) = cncr(i,j)
  514                 continue
  515               continue
                  endif
                  irel = (ixfb2(ifine)-ixfb2(lgrd(1)))*nhfnst 
     $                + nhfnst/nhf2(lgrd(1)) - nhfnst/nhf2(ifine)
                  jrel = (jyfb2(ifine)-jyfb2(lgrd(1)))*nhfnst
     $                + nhfnst/nhf2(lgrd(1)) - nhfnst/nhf2(ifine)
                endif
c
                DO 650 I = nhh+1,nhh*NFX2(IFINE)-nhh
                  DO 650 J = nhh+1,nhh*NFY2(IFINE)-nhh
c                    
c                    if this cell of this fine grid is covered by
c                    another inner fine grid, don't change value in
c                    this cell now.
c
                    if (ignum2(i+irel,j+jrel) .ne. ifine) go to 650
c
                    IF(LMAX) THEN
                      CNC2(I+irel,J+jrel,LL,KK)=
     &                 AMAX1(FACT*CONC(I,J),CNC2(I+irel,J+jrel,LL,KK))
                    ELSE IF(LTOT) THEN
                      CNC2(I+irel,J+jrel,LL,KK)=
     &                 FACT*CONC(I,J) + CNC2(I+irel,J+jrel,LL,KK)
                    ELSEIF(LDIFR) THEN
                      CNC1(I+irel,J+jrel,LL,KK)=
     &                     (CNC1(I+irel,J+jrel,LL,KK)-FACT*CONC(I,J))/
     &                                                (FACT*CONC(I,J))
                    ELSE
                      CNC1(I+irel,J+jrel,LL,KK)=
     &                        CNC1(I+irel,J+jrel,LL,KK)-FACT*CONC(I,J)
                    ENDIF
  650           CONTINUE
c
501         CONTINUE
500       CONTINUE
550     CONTINUE
c
      ENDIF
C
      RETURN
      
  999 WRITE(*,*)'ERROR IN GETZF!!! END OF CONCENTRATION FILE :'
      ierr = 1
      ENDTIM=999
      RETURN
C
 1005 FORMAT('1ST: AVERAGE HOUR: ',F10.0,I10)
 1010 FORMAT('2ND: AVERAGE HOUR: ',F10.0,I10)
      END
