*deck grdgro ********************************************************
      subroutine grdgro (z0,nd1,nx,ny,ifact,md1,z1)

*     creates a finer grid by linear interpolation

*     written by gw lundberg/sai oct '92

*     arguments--
*        z0    the values of the coarse grid
*        nd1   the declared first dimension of z0
*        nx,ny the number of x-cells and y-cells in z0 to use
*        ifact the number of z1 x-cells per z0 x-cells (the number
*              of z1 cells per z0 cell is ifact**2)
*        z1    the returned values of the fine grid

*     note--z1 should be declared as z1(ifact*nx,ifact*ny)

*     ---------------------------------------------------------------

      integer*4 nx,ny,nd1
      real*4 z0(nd1,*)
      integer*4 ifact
      real*4 z1(md1,*)

*     ---------------------------------------------------------------

*     ---note: fine grid cells have unit size; coarse grid cells
*              contain ifact*ifact unit cells
*
      finv = 1./real(ifact)
      nfudge = (ifact-1)/2
*
      do j1=1,ifact*ny
         y = real(j1) - 0.5

         j0 = (j1+nfudge)/ifact
         j0p1 = j0 + 1
         if (j0 .lt. 2) then
            j0 = 2
            j0p1 = j0
         elseif (j0 .gt. ny-2) then
            j0 = ny-1
            j0p1 = j0
         endif
         ylo = real(ifact)*(real(j0)-0.5)

         do i1=1,ifact*nx
            x = real(i1) - 0.5

            i0 = (i1+nfudge)/ifact
            i0p1 = i0 + 1
            if (i0 .lt. 2) then
               i0 = 2
               i0p1 = i0
            elseif (i0 .gt. nx-2) then
               i0 = nx-1
               i0p1 = i0
            endif
            xlo = real(ifact)*(real(i0)-0.5)

*           ---apply double linear interpolation
            dzdy = (z0(i0,j0p1)-z0(i0,j0))*finv
            zlft = dzdy * (y-ylo) + z0(i0,j0)

            dzdy = (z0(i0p1,j0p1)-z0(i0p1,j0))*finv
            zrgt = dzdy * (y-ylo) + z0(i0p1,j0)

            dzdx = (zrgt-zlft)*finv
            z1(i1,j1) = dzdx * (x-xlo) + zlft
         enddo
      enddo
      end
