c--------------------------------------------------------------------c
c          UPS-1 UAM-V POSTPROCESSING PACKAGE:   EXTRACT             c
c          VERSION 1.1                                               c
c--------------------------------------------------------------------c
      subroutine gtvlvl(ISTART)
      include 'xtract.inc'
      include 'xtract2.inc'
c     real cellzb(mxx,mxy,mxz)
C
C...READ FILE HEADERS AND RETURN IF ISTART = 1
C   (CHECK IF NULL FILES, SET DEFAULT TEMPERATURE AND PRESSURE
C    IF SO)
C
      IF(ISTART.eq.1) then
        read(irtp,end=10) timr1
        rewind irtp
        idtr1=0
        idtr2=0
        timr1 = 0.
        timr2 = 0.
        go to 30
   10   write(*,*) 'SURFACE-PRESSURE FILE IS NULL'
        write(*,*) 'SETTING DEFAULT PRESSURE OF 1 ATM'
        idtr1 = 9000000
        idtr2 = idtr1
        timr1 = 0.
        timr2 = 0.
        do 20 j=1,nyrd
          do 20 i=1,nxrd
            sfcp(i,j) = 1013.
   20   continue
c
   30   read(idfb,end=40) timd1
        rewind idfb
        idtd1=0
        idtd2=0
        timd1 = 0.
        timd2 = 0.
        go to 60
   40   write(*,*) 'TEMPERATURE FILE IS NULL'
        write(*,*) 'SETTING DEFAULT TEMPERATURE OF 298 K'
        idtd1 = 9000000
        idtd2 = idtd1
        timd1 = 0.
        timd2 = 0.
        do 50 k=1,nzrd
          do 50 j=1,nyrd
            do 50 i=1,nxrd
              temp(i,j,k) = 298.
   50   continue
60      ztop=0.0
        do 401 i = 1,nxrd
          do 402 j = 1,nyrd
            do 403 k = 1,nzrd
	      cellzf(i,j,k)=(sig(k)+sig(k+1))/2.0
  403       continue
  402     continue
  401   continue
c
      endif
C
C    READS UAM-V PRESSURE-INTERFACE HEIGHTS FILE
C    AND UAM-V TEMPERATURE FILE, CALCULATING CONVERSION
C    FACTORS FOR ug/m^3 to PPM AND LAYER MIDPOINTS
C
 75   CONTINUE
      tchk = timr1 + 24.*float(idtr1-ibdat)
      IF(TCHK.LT.BEGTIM)THEN
c       do 100 k = 1,nzrd
          READ(IRTP,END=998)timr1,idtr1,
     &                           ((SFCP(I,J),I=1,NXrd),J=1,NYrd)
c100    continue
        timr1=float(nint(timr1/100.))
        if (idtr1 .gt. 99999) then
          call caltoj(idtr1,idd)
          idtr1 = idd
        endif
        IDTR2=IDTR1
        TIMR2=TIMR1+1.
        IF(TIMR2.ge.24.) then
          timr2=timr2-24.
          idtr2=idtr2+1
        endif
        WRITE(*,*)'SFCP FILE TIME: ',IDTR1,TIMR1,IDTR2,TIMR2
        goto 75
      ENDIF
C
 80   CONTINUE
c
c     READ TEMPERATURE FILE
c
      tchk = timd1 + 24.*float(idtd2 - ibdat)
c     write(*,*) begtim,tchk,idtd2,ibdat
      IF(TCHK.LT.BEGTIM)THEN
        READ(Idfb,end=999)
        DO 200 K = 1,NZrd
          READ(idfb)TIMD1,IDTD1,((TEMP(I,J,K),I=1,NXrd),J=1,NYrd)
200     CONTINUE
        timd1=float(nint(timd1/100.))
        if (idtd1 .gt. 99999) then
          call caltoj(idtd1,idd)
          idtd1 = idd
        endif
        IDTd2=IDTd1
        TIMd2=TIMd1+1.
        WRITE(*,*)'TEMPERATURE FILE TIME: ',IDTD1,TIMD1,IDTD2,TIMD2
        goto 80
      ENDIF
C
      ztop=0.0
      do 201 i = 1,nxrd
        do 202 j = 1,nyrd
          if (sfcp(i,j).lt.0.) then
	    do k=1,nzrd
	     press(i,j,k)=-999.
	    enddo
	    goto 202
	  endif
          pstar(i,j) = sfcp(i,j) - ptop
          do 203 k = 1,nzrd
            prsupr = sig(k+1)*pstar(i,j) + ptop
            prslwr = sig(k)*pstar(i,j) + ptop
            press(i,j,k) = (prsupr + prslwr)/2.
	    cellzf(i,j,k)=(sig(k)+sig(k+1))/2.0
  203     continue
  202   continue
  201 continue
c
      RETURN
998   write(*,*)'END OF SURFACE PRESSURE FILE'
      stop
999   write(*,*)'END OF TEMPERATURE FILE'
      stop
      END 
