c--------------------------------------------------------------------c
c          ATDM POSTPROCESSING PACKAGE:   EXTRACT                    c
c          10/30/95   CAE                                            c
c--------------------------------------------------------------------c
      SUBROUTINE RDHDR(LUN)
      include 'xtract.inc'
      include 'xtract2.inc'
      character*10 mdum
C
C....READ FILE HEADER
c
c... Modified for ATDM extractions;  CAE 9/95
c
      IF(LUN.EQ.ICNC1) THEN
        READ (LUN)FILNAM,(mNOTE(i),i=1,10),(note(i),i=11,60),
     &                NOSEG,NOSPEC1,IDATB,TIMBEG,JDATE,TIMEND
        WRITE(*,2050) 
     &    FILNAM,NOTE,NOSEG,NOSPEC1,IDATB,TIMBEG,JDATE,TIMEND
      ELSE
        READ (LUN)FILNAM,(mNOTE(i),i=1,10),(note(i),i=11,60),
     &         NOSEG,NOSPEC2,IDATB,TIMBEG,JDATE,TIMEND
        WRITE(*,2050) 
     &   FILNAM,NOTE,NOSEG,NOSPEC2,IDATB,TIMBEG,JDATE,TIMEND
      ENDIF
c
c  if file name is INSTANT this is a file with
c  concentrations in PPM.  linst set to true
c
      write(mdum,'(10a1)') filnam
      if (mdum .eq. 'INSTANT   ') linst = .true.
c
c  if file name is DEPOSITION this is a file with
c  deposition totals in G/KM2.  ldepn set to true
c
      if (mdum .eq. 'DEPOSITION') ldepn = .true.
C
      IF(LUN.EQ.ICNC1) THEN
        READ (LUN) XREF,YREF,IUTM,XORG,YORG,DELX,DELY,NX,
     $   NY,NZ,Nzlowr,nzuppr,ZHTSUR,ZminLW,ZminUP
        WRITE(*,2001) XREF,YREF,IUTM,XORG,YORG,DELX,DELY,NX,
     $   NY,NZ,nzlowr,nzuppr,zHTSUR,zminLW,zminUP
        READ  (LUN) ILOCX,ILOCY, NX,NY
        WRITE(*,1002) ILOCX,ILOCY, NX,NY
        IF ( NX .GT. MXX .OR. NY .GT. MXY .OR. NZ .GT. MXZ)THEN
          write(*,*)'*** ERROR-- REDIMENSION MXX,MXY,MXZ',
     &        mxx,mxy,mxz,nx,ny,nz
        ENDIF
      ELSE
        READ (LUN) XREF2,YREF2,IUTM2,XORG2,YORG2,DELX2,DELY2,NX2,
     $   NY2,NZ2,Nzlowr2,nzuppr2,ZHTSUR2,ZminLW2,ZminUP2
        WRITE(*,2001) XREF2,YREF2,IUTM2,XORG2,YORG2,DELX2,DELY2,NX2,
     $   NY2,NZ2,nzlowr2,nzuppr2,zHTSUR2,zminLW2,zminUP2
        READ  (LUN) ILOCX2,ILOCY2, NX2,NY2
        WRITE(*,1002) ILOCX2,ILOCY2, NX2,NY2
        IF ( NX2 .GT. MXX .OR. NY2 .GT. MXY .OR. NZ2 .GT. MXZ)THEN
          write(*,*)'*** ERROR-- REDIMENSION MXX,MXY,MXZ',
     &        mxx,mxy,mxz,nx2,ny2,nz2
        ENDIF
      ENDIF
c
c     Determine whether this is an ordinary AVERAGE file
c     or an extraction file. DETERMINE UNITS
c
      IF (LUN.EQ.ICNC1) THEN
        NSPC = NOSPEC1
        NFIL = 1
        DO 225 L = 1,NOSPEC1
           XFACT(L,1)=1.
 225    CONTINUE
      ELSE
        NFIL = 2
        NSPC = NOSPEC2
        DO 235 L = 1,NOSPEC2
           XFACT(L,2)=1.
 235    CONTINUE
      ENDIF
c
c   IF INPUT FILE IS AN EXTRACTION FILE, SET IFRST=.FALSE.
c   BOUNDARY CELLS WILL NOT BE SET
c
      ifrst=.true.
      WRITE(lunit,'(8a1)')(mNOTE(I),I=1,8)
      write(*,'(a8)') lunit
      IF (LUNIT(1:2).eq.'XY') THEN
        ifrst=.false.
        IS1=NOTE(11)
        IS2=NOTE(12)
        JS1=NOTE(13)
        JS2=NOTE(14)
        DO 300 N = 1,NSPC
          NN=NZ+14+N
          xfact(n,nfil)=1.
          IF(NOTE(NN).eq.2) xfact(n,nfil)=1.e-3
          IF(NOTE(NN).eq.4) xfact(n,nfil)=1.e+3
          IF(NOTE(NN).eq.5) xfact(n,nfil)=1.e+5
          IF(NOTE(NN).eq.6) xfact(n,nfil)=1.e-3
          IF(NOTE(NN).eq.8) xfact(n,nfil)=1.e-3
          IF(NOTE(NN).eq.9) xfact(n,nfil)=1.e-6
          IF(NOTE(NN).eq.10) xfact(n,nfil)=1.e-9
 300    CONTINUE
      ENDIF

      IF(LUN.EQ.ICNC1) THEN
        READ  (LUN) ((MSPEC1(I,J),I=1,10),J=1,NOSPEC1)
        WRITE(*,*)'FILE ONE SPECIES LIST:'
        WRITE(*,2010)(J,(MSPEC1(M,J),M=1,10),J=1,NOSPEC1)
      ELSE
        READ  (LUN) ((MSPEC2(I,J),I=1,10),J=1,NOSPEC2)
        WRITE(*,*)'FILE TWO SPECIES LIST:'
        WRITE(*,2010)(J,(MSPEC2(M,J),M=1,10),J=1,NOSPEC2)
      ENDIF
      return
       
 1002 FORMAT(4I5)
 2001 FORMAT(F10.1,1X,F10.1,1X,I3,F10.1,1X,F10.1,1X,2F6.3,5I4,3F7.0)
 2050 format(10a1,60a1,1x,2i5,1x,i6,f10.0,1x,i6,f10.0)
 2010 format(6(4('[',i2,']',2x,10a1),/),/)

      END
