c--------------------------------------------------------------------c
c          ATDM POSTPROCESSING PACKAGE:   EXTRACT                    c
c          9/11/95   CAE                                             c
c--------------------------------------------------------------------c
      SUBROUTINE RDHDRF(LUN)
      include 'xtract.inc'
      include 'xtract2.inc'
      character*80  msg
      character*10  mavspc(mxspc)
c      integer mtmp(10,mxspc)
      character*4 mtmp(10,mxspc)
c
c   Fine Grid file species are assumed to be in the same order as the
c   coarse grid file
c
C
C....READ UAM FILE HEADER
C
      IF(LUN.EQ.ICNC1f) THEN
        READ (LUN)MSG
        READ (LUN)numfin1,nspc1f
        WRITE(*,2050) msg,numfin1,nspc1f
        if (linst) then
          READ (LUN) ((mtmp(i,j),i=1,10),j=1,nspc1f)
          WRITE(*,*)'FINE GRID SPECIES LIST:'
          WRITE(*,2020)(J,(MTMP(I,J),I=1,10),J=1,NSPC1F)
        else
          READ (LUN) (mavspc(j),j=1,nspc1f)
          WRITE(*,*)'FINE GRID SPECIES LIST:'
          WRITE(*,2010)(J,MAVSPC(J),J=1,NSPC1F)
        endif
        do 100 ifine = 1,numfin1
         READ (LUN)ixfb1(ifine),jyfb1(ifine),ixfe1(ifine),jyfe1(ifine),
     &    nhf1(ifine),nvf1(ifine),nfx1(ifine),nfy1(ifine),nfz1(ifine),
     &    ifgptr1(ifine), ifglvl1(ifine) 
         WRITE(*,*) 'GRID NESTING PARAMETERS:'
         WRITE (*,2060)ifine,ixfb1(ifine),jyfb1(ifine),
     &                 ixfe1(ifine),jyfe1(ifine),
     &                 nhf1(ifine),nvf1(ifine),
     &                 nfx1(ifine),nfy1(ifine),nfz1(ifine),
     &                 ifgptr1(ifine), ifglvl1(ifine) 
         delfx1(ifine) = delx/float(nhf1(ifine))
         delfy1(ifine) = dely/float(nhf1(ifine))
c        IF ( NFX1(IFINE).GT.MXFX.OR.NFY1(IFINE).GT.MXFY.OR.
c    &    NFZ1(IFINE).GT.MXFZ)THEN
c         write(*,*)'*** ERROR-- REDIMENSION MXFX,MXFY,MXFZ',
c    &          mxfx,mxfy,mxfz,nfx1(ifine),nfy1(ifine),nfz1(ifine)
c        ENDIF
 100    continue
c
c  if coarse grid not in use, assume that first selected fine
c  grid is to be used for outside dimensions etc.
c
        nn = id(0,lgrd,ngrd)
        if (nn .lt. 0) then
          IF ( NFX1(lgrd(1)).GT.MXX.OR.NFY1(lgrd(1)).GT.MXY.OR.
     &      NFZ1(lgrd(1)).GT.MXZ)THEN
              write(*,*)'*** ERROR-- REDIMENSION MXX,MXY,MXZ',
     &          mxx,mxy,mxz,nfx1(lgrd(1)),nfy1(lgrd(1)),nfz1(lgrd(1))
              stop1
          ENDIF
          nn = lgrd(1)
          nxi = nfx1(nn)
          nyi = nfy1(nn)
c         nz = nfz1(nn)
          nzi=nfz1(nn)
          xorg = xorg + float(ixfb1(nn)-1)*delx - delfx1(nn)
          yorg = yorg + float(jyfb1(nn)-1)*dely - delfy1(nn)
          delx = delfx1(nn)
          dely = delfy1(nn)
	else
	  nzi=nz
        endif

      ELSE
        READ (LUN)MSG
        READ (LUN)NUMFIN2,nspc2f
        WRITE(*,2050) msg,numfin2,nspc1
        READ (LUN) 
        do 120 ifine = 1,numfin2
         READ (LUN)ixfb2(ifine),jyfb2(ifine),ixfe2(ifine),jyfe2(ifine),
     &    nhf2(ifine),nvf2(ifine),nfx2(ifine),nfy2(ifine),nfz2(ifine),
     &    ifgptr2(ifine), ifglvl2(ifine) 
        delfx2(ifine) = delx/float(nhf2(ifine))
        delfy2(ifine) = dely/float(nhf2(ifine))
c       IF ( NFX2(IFINE).GT.MXFX.OR.NFY2(IFINE).GT.MXFY.OR.
c    &    NFZ2(IFINE).GT.MXFZ)THEN
c         write(*,*)'*** ERROR-- REDIMENSION MXFX,MXFY,MXFZ',
c    &          mxfx,mxfy,mxfz,nfx2(ifine),nfy2(ifine),nfz2(ifine)
c       ENDIF
 120    continue
      ENDIF
C
c
       
 1001 FORMAT(10X,10A1/5X,60A1/5X,4I10//)
 1002 FORMAT(4I5)
 1003 FORMAT(10A1)
 1005 FORMAT(5X,2(I10,F10.2))
 1006 FORMAT(I4,10A1)
 1007 FORMAT(9E14.9)
 2001 FORMAT(F10.1,1X,F10.1,1X,I3,F10.1,1X,F10.1,1X,2F6.0,5I4,3F7.0)
 2050 format(a80,/,2i10)
 2060 format('FG #',i2,5x,2i5,/,11x,2i5,/11x,2i5,/,11x,3i5,/,11x,2i5)
 2010  format(6(4('[',i2,']',2x,a10),/),/)
 2020  format(6(4('[',i2,']',2x,10a1),/),/)
      END
