c--------------------------------------------------------------------c
c          UPS-1 UAM POSTPROCESSING PACKAGE:   EXTRACT               c
c          VERSION 1.0                                               c
c--------------------------------------------------------------------c
      subroutine rdobs
      include 'xtract.inc'
      include 'xtract2.inc'
      character*20 site
      integer spec(10)
      real arr(mxhrs)
c
c... This subroutine is designed to read one observational data file
c....with:
c          NSTN                            (I5)
c          STNAM(N),UTMX(N),UTMY(N)        (a20,f7.0,f11.0)
c          STNAM, MSPEC ,IDATE             (a20,6x,a10,i6,4x,a8)
c          (OBS(I),I=1,24)                 (7f10.2)
c
c    The subroutine will read to the end of the observation file
c    STATION NAME THAT DO NOT MATCH THE HEADER NAME WILL BE
c    DISCARDED
C 
c....Need to modify for multiple species observations
c
c    READ STATION NAME AND LOCATION, CONVERTING TO GRID COORDS.
c
c     INITIALIZE UNITS ARRAY
c
      DO 101 l = 1,mxspc2
       iunit(l)=-1
 101  CONTINUE
c
      read(istnd,*) nstn
      nstn=abs(nstn)
      if ( nstn .gt. mxstn ) then
	 write(*,*) ' Number of observation sites exceeded !!'
	 stop
      endif
c
c     READ STATION NAMES AND LOCATIONS, CHECKING LOCATIONS.
c
      n=0
      do 100 while (n .lt. nstn )
        n = n + 1
	if ( iutm .lt. 0 ) then
           read(istnd,1001)stnam(n),xutm,yutm
	else
           read(istnd,1000)stnam(n),xutm,yutm
	endif
        ficl(n)=(xutm-xorg)/dxi + 0.5
        fjcl(n)=(yutm-yorg)/dyi + 0.5
        i1=int(ficl(n))
        i2 = i1 + 1
        j1 = int(fjcl(n))
        j2 = j1 + 1
        if(j1.lt.1.or.j2.gt.nyi) then
          write(*,*)'WARNING: STATION OUTSIDE DOMAIN ',stnam(n),
     &           xutm,yutm,ficl(n),fjcl(n)
          n=n-1
          nstn=nstn-1
          goto 100
        endif
        if(i1.lt.1.or.i2.gt.nxi) then
          write(*,*)'WARNING: STATION OUTSIDE DOMAIN ',stnam(n),
     &           xutm,yutm,ficl(n),fjcl(n)
          n=n-1
          nstn=nstn-1
          goto 100
        endif
	if ( ifrst ) then
           if ( (i1.lt.ilfti(j1).or.i1.lt.ilfti(j2))   
     &       .or. (i2.gt.irgti(j1).or.i2.gt.irgti(j2)) ) then
             write(*,*)'WARNING: STATION OUTSIDE DOMAIN ',stnam(n),
     &             xutm,yutm,ficl(n),fjcl(n)
             n=n-1
             nstn=nstn-1
             goto 100
           endif
	endif
100   continue
c
c... READ OBSERVATIONAL DATA AND CONVERT TO WORKING UNITS
c
 23   read(istnd,1010,end=999)site,(spec(l),l=1,10),lodate,lunit
      iddat=lodate-idat1
c
c...Find site index and identify species
c
      indstn=-1
      do 200 n = 1,nstn
        if(site.eq.stnam(n)) indstn=n
 200  continue
      ll = ident(spec,mspcw,NVAR)
      read(istnd,1020)(arr(i),i=1,24)
c
c...Transfer observation to global array
c
       if(indstn.gt.0.and.ll.gt.0) then 
       do 300 ih = 1,24
        obs(ih,indstn,ll)=arr(ih)
 300   continue
       if(iunit(ll).lt.0) THEN
         if (LUNIT(1:3).EQ.'PPM') iunit(ll)=1
         if (LUNIT(1:3).EQ.'PPB') iunit(ll)=2
         if (LUNIT(1:5).EQ.'G/KM2') iunit(ll)=3
         if (LUNIT(1:6).EQ.'KG/KM2') iunit(ll)=4
         if (LUNIT(1:5).EQ.'KG/HA') iunit(ll)=5
         if (LUNIT(1:6).EQ.'MG/KM2') iunit(ll)=6
         IF (LUNIT(1:5).EQ.'UG/M3') iunit(ll)=7
         if (LUNIT(1:5).EQ.'NG/M3') iunit(ll)=8
         if (LUNIT(1:5).EQ.'PG/M3') iunit(ll)=9
         if (LUNIT(1:5).EQ.'FG/M3') iunit(ll)=10
         if (LUNIT(1:7).EQ.'UG/M2') iunit(ll)=11
c
         if(iunit(ll).lt.0) then
           write(*,2005)lunit,(spec(m),m=1,10),stnam(indstn)
           stop
         endif
       ENDIF
       else
       write(*,2000)site,(spec(i),i=1,10)
       endif
       goto 23
999    write(*,*)'END OF OBSERVATION FILE...EXITING OBSRD'
       return
       
1000  format(a20,f7.0,f11.0)
1001  format(a20,f8.0,3x,f8.0)
1010  format(a20,6x,10a1,i6,4x,a8)
1020  format(7f10.2)
1030  format(i3)
1060  format(i6)
2000  format('SITE: ',a20,' SPECIES: ',10a1,
     &        ' NOT FOUND...DISCARDING')
2005   format('*** ERROR READING UNITS : ',a8,10a1,a20)
       end
