c--------------------------------------------------------------------c
c          ATDM POSTPROCESSING PACKAGE:   EXTRACT                    c
c          9/11/95  CAE                                              c
c--------------------------------------------------------------------c
      SUBROUTINE REBND (LUN,MXY,nox,noy,ILFT,IRGT)
      SAVE
C
C     ----- READ IN ILFT AND IRGT FROM BOUNDARY FILE
C----------------------------------------------------------------
C
      DIMENSION ILFT(mxy),IRGT(mxy)
      DIMENSION IFILE(10),NOTE(60),MSPEC(10,36)
C
C-----------------------------------------------------------------
C
C     ----- READ IN BOUNDARY DEFINITION
C
      READ  (LUN,end=400) IFILE, NOTE, NSEG, NSPECS, 
     $                  IDUM, ZDUM, IDUM, ZDUM
      READ  (LUN) ZDUM, ZDUM, IDUM, ZDUM, ZDUM, ZDUM, ZDUM,
     $        NX, NY, IDUM, IDUM, IDUM, ZDUM, ZDUM, ZDUM

      WRITE (*,1114) NX,NY
1114  FORMAT ('FROM BOUNDARY FILE: NX,NY = ',2I5)
      if (nx .ne. nox .or. ny .ne. noy) then
        write(*,*) '********* ERROR ***********'
        write(*,*) 'BOUNDARY file size is not consistent with '
        write(*,*) 'domain size, which is ', nox, noy
        stop
      endif
C
C
C     ----- CHECK DIMENSION FOR NY
C
      IF (NY.GT.MXY) GO TO 900
C
      READ  (LUN) IDUM, IDUM, IDUM, IDUM
      READ  (LUN) ((MSPEC(M,L),M=1,10),L=1,NSPECS)
C
      DO 10 NS=1,NSEG
         READ(LUN) IDUM, IDUM, NC, (ILFT(L),IDUM,IDUM,IDUM,L=1,NC)
         READ(LUN) IDUM, IDUM, NC, (IRGT(L),IDUM,IDUM,IDUM,L=1,NC)
  10  CONTINUE
C
      GO TO 999
c
c   if boundary file is empty, just set ilft and irgt to very edge
c
 400  write(*,*) 'BOUNDARY file empty.  Setting ILFT and IRGT to'
      write(*,*) 'edge of rectangle.'
      ilft(1) = 0
      irgt(1) = 0
      ilft(noy) = 0
      irgt(noy) = 0
      do 410 j=2,noy-1
        ilft(j) = 2
        irgt(j) = nox - 1
  410 continue
      go to 999
C
C     ----- ERROR MESSAGES
C
900   WRITE (*,905) NP6
905   FORMAT (3X,'--- NP = ',I5,' GREATER THAN MXPTS')
      GO TO 999
C
910   WRITE (*,915) (ILFT(I),IRGT(I),I=1,NY)
915   FORMAT (3X,'--- SOMETHINGS WEIRD :'/100(3X,2I5/))
      GO TO 999
C
920   WRITE (*,925) IY,IFRSTY,ILASTY
925   FORMAT (3X,'--- NULL ROW WITHIN REGION --'/
     &        10X,'IY,IFRSTY,ILASTY = ',3I5)
C
999   RETURN
      END
