c--------------------------------------------------------------------c
c          ATDM POSTPROCESSING PACKAGE:   EXTRACT                    c
c          10/30/95   CAE                                            c
c--------------------------------------------------------------------c
      subroutine tseries
      include 'xtract.inc'
      include 'xtract2.inc'
      character*80 ipath
      character*60 fn
      character*2 xystr
      character*3 airstr,tststr
      data xystr/'XY'/
      data airstr/'AIR'/
c
c....This program will create a MAP or MAX file
c
      write(*,*)'ENTER COARSE GRID FILE PATHNAME:'
      read(*,1000) ipath
      write(*,*)'OPENING COARSE GRID FILE:',ipath
      open(icnc1,file=ipath,form='unformatted',status='old')
      call flush(6)
      call rdhdr(icnc1)
c
      write(*,*)'ENTER FINE GRID FILE PATHNAME:'
      read(*,1000) ipath
      if(ipath.ne.' ')  then
        write(*,*)'OPENING FINE GRID FILE:',ipath
        open(icnc1f,file=ipath,form='unformatted',status='old')
        write(*,*)'ENTER NUMBER OF GRIDS TO USE (INCLUDING COARSE):'
        read(*,1000) ipath
        write(*,1000)ipath
        read(ipath,*) ngrd
        write(*,*)'ENTER GRID NUMBERS FROM WHICH TO EXTRACT (0=COARSE):'
        read(*,1000) ipath
        write(*,1000)ipath
        read(ipath,*,end=48) (lgrd(n),n=1,ngrd),deltat
	goto 49
 48     deltat=1.0
 49     call rdhdrf(icnc1f)

	do 491 nn=1,ngrd
	   if ( lgrd(nn) .le. 0 ) goto 491
	   ifn=lgrd(nn)
	   if ( ngrd .gt. 1 ) then
	     if ( nfz1(ifn) .ne. nz ) then
	       write(*,*) ' Multi-grid extractions with'
	       write(*,*) ' vertical nesting NOT SUPPORTED'
	       write(*,*) ' Extract vertical nested grids separately'
	       stop
	     endif
	     nzi=nz
     	     nxrd=nx
	     nyrd=ny
	     nzrd=nz
	   else
	     nzi=nfz1(ifn)
	     nxrd=nfx1(ifn)
	     nyrd=nfy1(ifn)
 	     nzrd=nfz1(ifn)
	   endif
 491    continue
      else
        icnc1f=0
        numfin1 = 0
        numfin2 = 0
	nxrd=nx
	nyrd=ny
	nzrd=nz
	ngrd=1
	lgrd(1)=0
	nzi=nz
      endif
c
c   if fine grids are included, find finest subdivision and determine
c   ultimate size of overall grid (this assumes that largest number
c   of subdivisions wrt coarse grid will work, but if we had one 
c   grid that was 3 and one that was 5 (e.g.) we would need lowest
c   common denominator (15).  The below would have to be changed
c   in that case)
c
      nhmax=1
      if (icnc1f .ne. 0) then
        ncrs = id(0,lgrd,ngrd)
        if (ncrs .ge. 0) then
          do 50 nn=1,ngrd
            if (lgrd(nn).eq.0) goto 50
            ifine = lgrd(nn)
            if (nhf1(ifine) .gt. nhmax) nhmax = nhf1(ifine)
   50     continue
          nxi = nx*nhmax
          nyi = ny*nhmax
          dxi = delx/float(nhmax)
          dyi = dely/float(nhmax)
        else
          if1 = lgrd(1)
          do 55 nn=2,ngrd
            ifine = lgrd(nn)
            nhh = nhf1(ifine)/nhf1(if1)
            if (nhh .gt. nhmax) nhmax = nhh
   55     continue
          nxi = nfx1(if1)*nhmax
          nyi = nfy1(if1)*nhmax
          dxi = delfx1(if1)/float(nhmax)
          dyi = delfy1(if1)/float(nhmax)
        endif
      else
        nxi = nx
        nyi = ny
        dxi = delx
        dyi = dely
      endif
c
      IF ( NXI.GT.MXX.OR.NYI.GT.MXY.OR.NZI.GT.MXZ) THEN
        write(*,*)'*** ERROR-- GROWN GRID EXCEEDS ARRAY SIZE'
        WRITE(*,*)'            REDIMENSION MXX,MXY,MXZ',
     &          mxx,mxy,mxz,nxi,nyi,nzi
        stop1
      ENDIF
c
      write(*,*)'ENTER BOUNDARY FILE PATHNAME:'
      read(*,1000)ipath
      write(*,*)'OPENING BOUNDARY FILE:',ipath
      open(ibnd,file=ipath,form='unformatted',status='old')
      if (icnc1f .ne. 0 .and. ncrs .lt. 0) then
        if1 = lgrd(1)
	if ( ifrst ) then
           call rebnd(ibnd,mxy,nfx1(if1),nfy1(if1),ilft,irgt)
           call adjbnd(nhmax,nfx1(if1),nfy1(if1),ilft,irgt,
     $                    nxi,nyi,ilfti,irgti)
	endif
      else 
	if ( ifrst ) then
           call rebnd(ibnd,mxy,nx,ny,ilft,irgt)
           call adjbnd(nhmax,nx,ny,ilft,irgt,nxi,nyi,ilfti,irgti)
	endif
      endif
c
      write(*,*)'ENTER OBSERVATION DATA FILE PATHANME:'
      read(*,1000) ipath
      write(*,*)'OPENING OBSERVATION  FILE:',ipath
      open(istnd,file=ipath,status='old')
c
      write(*,*)'ENTER OUTPUT FILE PATHANME:'
      read(*,1000) ipath
      write(*,*)'OPENING OUTPUT FILE:',ipath
      open(iwr,file=ipath)
c
      write(*,*)'ENTER BEGINNING TIME AND DATE OF FIRST HOUR'
      write(*,*)'TO EXTRACT DATA:'
      read(*,1000)ipath
      read(ipath,*)tim1,idat1
      if(idat1.gt.99999)then
        call caltoj(idat1,jdat)
        idat1=jdat
      endif
      write(*,1030)TIM1,IDAT1
      write(*,*)'ENTER ENDING TIME AND DATE OF LAST HOUR'
      write(*,*)'TO EXTRACT DATA:'
      read(*,1000)ipath
      read(ipath,*)tim2,idat2
      if(idat2.gt.99999)then
        call caltoj(idat2,jdat)
        idat2=jdat
      endif
      write(*,1030)TIM2,IDAT2
c
      nhrs=(idat2-idat1)*24 + tim2-tim1
      write(*,*) ' NHRS :',nhrs
c
      nlvl=1
      level(1)=1
c
      LDIF = .FALSE.
      LMAX = .FALSE.
      LAVE = .FALSE.
      LTOT = .FALSE.
      LSUM = .FALSE.
c
c   set mapping of grid nests
c
      call fgmap
c
      WRITE(*,*)'ENTER NUMBER OF SPECIES TO EXTRACT:'
      read(*,1000)ipath
      READ(ipath,*)NVAR
c
      IF (NVAR .GT. MXSPC2 ) THEN
        WRITE(*,*)'*** ERROR IN XYSEC: NVAR GREATER THAN MXSPC',
     &             nvar,mxspc2
        stop
      ENDIF
c
      WRITE(*,1005)NVAR
      write(*,*)'ENTER SPECIES TO EXTRACT FROM AVERAGE FILE:'
c
        do 111 l = 1,nvar
          do 112 i = 1,nxi
            do 112 j = 1,nyi
              do 112 k = 1,nzi
                cnc1(i,j,l,k)=0.
                cnc2(i,j,l,k)=0.
 112      continue
	  do 113 n=1,mxstn
	    do 113 ii=1,mxhrs
	       tsdat(ii,n,l)=-9
	       tsmax(ii,n,l)=-9
	       tsmin(ii,n,l)=-9
	       obs(ii,n,l)=-9
 113      continue
 111    continue
c
      DO 100 L = 1,NVAR
        iunit(l)=-1
        read(*,1000)ipath
        read(ipath,1020)(MSPCW(M,L),M=1,10)
        write(*,1020)(MSPCW(M,L),M=1,10)
        LVAR1(L)=IDENT(MSPCW(1,L),MSPEC1,NOSPEC1)
        if (lvar1(l).eq.-9) then
          write(*,2010)(mspcw(m,l),m=1,10)
          stop8
        endif
100   continue
c
      call rdobs
      close (istnd)
c
 10   if (icnc1f .gt. 0) then
        nn = id(0,lgrd,ngrd)
        if (nn .ge. 0) then
          call getz(ierr)
          if(ierr.eq.1)then
            write(*,*)'END OF COARSE GRID AVERAGE FILE.... EXITING'
            close(icnc1)
            close(ibnd)
            if(ldif)close(icnc2)
            close(iwr)
            return
          endif
        endif
        call getzf(ierr,deltat)
        if(ierr.eq.1)then
          write(*,*)'END OF FINE GRID AVERAGE FILE.... EXITING'
          close(icnc1f)
          close(ibnd)
          if(ldif)close(icnc2f)
          close(iwr)
          return
        endif
      else
        call getz(ierr)
        if(ierr.eq.1)then
          write(*,*)'END OF COARSE GRID AVERAGE FILE.... EXITING'
          close(icnc1)
          close(ibnd)
          if(ldif)close(icnc2)
          close(iwr)
          return
        endif
      endif
c
c  time checks modified by tcm, 10/21/92
c
      tchk = begtim + 24.*float(ibdat-idat1)
      if (tchk .lt. tim1) go to 10
C
c  Fill prediction arrays for each hour
c
       ih=int(begtim+1.001)+24*(ibdat-idat1)
       if ( ih .gt. mxhrs ) then
	 write(*,*) '*** ERROR: IH greater than MXHRS',mxhrs
	 stop
       endif
       call gpext
c
       tchk = endtim + 24.*float(iedat-idat2) + .05
       if (tchk .ge. tim2) then
	 call wrtgp
	 write(*,*) ' Normal end of program ... Exiting'
         close(icnc1)
         close(iwr)
         return
       ENDIF
       goto 10

1000  format(20x,a)
1005  format(20x,i3)
1020  format(10a1)
1021  format(10a1,f10.0)
1030  format(20x,f10.0,i10)
2000  format('[MAP]    N-HOURLY CONCENTRATION MAP',/,
     &       '[MAX]    MAXIMUM CONCENTRATION MAP',/,
     &       '[AVE]    N-HOUR AVERAGE CONCENTRATION MAP',/,
     &       '[DIF]    CONCENTRATION DIFFERENCE MAP',/,
     &       '[MXDIF]  MAXIMUM CONCENTRATION DIFERENCE MAP',/,
     &       '[TOT]    N-HOUR TOTAL MAP',/,
     &       '[SUM]    [MAP] FOR AN AGGREGATE SPECIES',/,
     &       '         ENTER SELECTION:',/,
     &       '------------------->')
2010   format('SPECIES NOT FOUND IN AVERAGE FILE!',10a1)
      end
