c--------------------------------------------------------------------c
c          ATDM POSTPROCESSING PACKAGE:   EXTRACT                    c
c          10/30/95   CAE                                            c
c--------------------------------------------------------------------c
      subroutine xysec
      include 'xtract.inc'
      include 'xtract2.inc'
      character*200 ipath
      character*60 fn
      character*11 fmt
      character*2 xystr
      character*3 airstr,tststr
      data xystr/'XY'/
      data airstr/'AIR'/
c
c....This program will create a MAP or MAX file
c
      write(*,*)'ENTER COARSE GRID FILE PATHNAME:'
      read(*,1000) ipath
      write(*,*)'OPENING COARSE GRID FILE:',ipath
      open(icnc1,file=ipath,form='unformatted',status='old')
      call flush(6)
      call rdhdr(icnc1)
c
      write(*,*)'ENTER FINE GRID FILE PATHNAME:'
      read(*,1000) ipath
      if(ipath.ne.' ')  then
        deltat=1.0
        write(*,*)'OPENING FINE GRID FILE:',ipath
        open(icnc1f,file=ipath,form='unformatted',status='old')
        write(*,*)'ENTER NUMBER OF GRIDS TO USE (INCLUDING COARSE):'
        read(*,1000) ipath
        write(*,1000)ipath
        read(ipath,*) ngrd
        write(*,*)'ENTER GRID NUMBERS FROM WHICH TO EXTRACT (0=COARSE):'
        read(*,1000) ipath
        write(*,1000)ipath
	write(fmt,5000) ngrd
 5000   format('(',i1,'I,f10.0)')
        read(ipath,fmt) (lgrd(n),n=1,ngrd),deltat
	if ( deltat .eq. 0. ) then
	   deltat=1.0
	endif
        write(*,*) 'Lgrd = ', lgrd
        write(*,*) 'Ngrd, deltat: ', ngrd, deltat
        write(*,*) 'fmt: ', fmt
 49     call rdhdrf(icnc1f)

	do 491 nn=1,ngrd
	   if ( lgrd(nn) .le. 0 ) then
	     nxrd=nx
	     nyrd=ny
	     nzrd=nz
	     nzi=nz
	     goto 492
	   endif
	   ifn=lgrd(nn)
	   if ( ngrd .gt. 1 ) then
	     if ( nfz1(ifn) .ne. nz ) then
	       write(*,*) ' Multi-grid extractions with'
	       write(*,*) ' vertical nesting NOT SUPPORTED'
	       write(*,*) ' Extract vertical nested grids separately'
	       stop
	     endif
	     nzi=nz
     	     nxrd=nx
	     nyrd=ny
	     nzrd=nz
	   else
	     nzi=nz
     	     nxrd=nx
	     nyrd=ny
	     nzrd=nz
c	     nzi=nfz1(ifn)
c	     nxrd=nfx1(ifn)
c	     nyrd=nfy1(ifn)
c 	     nzrd=nfz1(ifn)
	   endif
 491    continue
 492    continue
      else
        icnc1f=0
        numfin1 = 0
        numfin2 = 0
	nxrd=nx
	nyrd=ny
	nzrd=nz
	nzi=nz
	ngrd=1
	lgrd(1)=0
      endif
c
c   if fine grids are included, find finest subdivision and determine
c   ultimate size of overall grid (this assumes that largest number
c   of subdivisions wrt coarse grid will work, but if we had one 
c   grid that was 3 and one that was 5 (e.g.) we would need lowest
c   common denominator (15).  The below would have to be changed
c   in that case)
c
      nhmax=1
      if (icnc1f .ne. 0) then
        ncrs = id(0,lgrd,ngrd)
        if (ncrs .ge. 0) then
          do 50 nn=1,ngrd
            if (lgrd(nn).eq.0) goto 50
            ifine = lgrd(nn)
            if (nhf1(ifine) .gt. nhmax) nhmax = nhf1(ifine)
   50     continue
          nxi = nx*nhmax
          nyi = ny*nhmax
          dxi = delx/float(nhmax)
          dyi = dely/float(nhmax)
        else
          if1 = lgrd(1)
          do 55 nn=2,ngrd
            ifine = lgrd(nn)
            nhh = nhf1(ifine)/nhf1(if1)
            if (nhh .gt. nhmax) nhmax = nhh
   55     continue
          nxi = nfx1(if1)*nhmax
          nyi = nfy1(if1)*nhmax
          dxi = delfx1(if1)/float(nhmax)
          dyi = delfy1(if1)/float(nhmax)
        endif
      else
        nxi = nx
        nyi = ny
        dxi = delx
        dyi = dely
      endif
c
      IF ( NXI.GT.MXX.OR.NYI.GT.MXY.OR.NZI.GT.MXZ) THEN
        write(*,*)'*** ERROR-- GROWN GRID EXCEEDS ARRAY SIZE'
        WRITE(*,*)'            REDIMENSION MXX,MXY,MXZ',
     &          mxx,mxy,mxz,nxi,nyi,nzi
        stop1
      ENDIF
c
      write(*,*)'ENTER BOUNDARY FILE PATHNAME:'
      read(*,1000)ipath
      write(*,*)'OPENING BOUNDARY FILE:',ipath
      open(ibnd,file=ipath,form='unformatted',status='old')
      if (icnc1f .ne. 0 .and. ncrs .lt. 0) then
        if1 = lgrd(1)
	if ( ifrst ) then
           call rebnd(ibnd,mxy,nfx1(if1),nfy1(if1),ilft,irgt)
           nhrat = nhmax/nhf1(if1)
           call adjbnd(nhmax,nfx1(if1),nfy1(if1),ilft,irgt,
     $                    nxi,nyi,ilfti,irgti)
	endif
      else 
	if ( ifrst ) then
           call rebnd(ibnd,mxy,nx,ny,ilft,irgt)
           call adjbnd(nhmax,nx,ny,ilft,irgt,nxi,nyi,ilfti,irgti)
	endif
      endif
c
      write(*,*)'ENTER OUTPUT FILE PATHANME:'
      read(*,1000) ipath
      write(*,*)'OPENING OUTPUT FILE:',ipath
      open(iwr,file=ipath,form='unformatted')
c
      write(*,2000)
      read(*,1000)lans
      write(*,1000)lans
c
      LDIF = .FALSE.
      LMAX = .FALSE.
      LAVE = .FALSE.
      LTOT = .FALSE.
      LSUM = .FALSE.
      if(lans(1:3).eq.'SUM') then
       LSUM = .TRUE.
      endif
      if(lans(1:3).eq.'AVE') then
       LAVE=.TRUE.
      endif
      if(LANS(1:5).eq.'MXDIF')THEN
       LMAX=.TRUE.
       LDIF=.TRUE.
       WRITE(*,*)'ENTER 2ND COARSE GRID FILE PATHNAME:'
       read(*,1000)ipath
       open(icnc2,file=ipath,form='unformatted',status='old')
       call rdhdr(icnc2)
c
       if (icnc1f.ne.0) then
         WRITE(*,*)'ENTER 2ND FINE GRID FILE PATHNAME:'
         read(*,1000)ipath
         open(icnc2f,file=ipath,form='unformatted',status='old')
         call rdhdrf(icnc2f)
       endif
      ENDIF
      if(lans(1:3).eq.'MAX') THEN
       LMAX=.TRUE.
      ENDIF
      if(lans(1:3).eq.'TOT') THEN
       LTOT=.TRUE.
      ENDIF
      if(lans(1:3).eq.'DIF')THEN
       if(lans(1:4).eq.'DIFR') ldifr=.true.
       LDIF=.TRUE.
       WRITE(*,*)'ENTER 2ND COARSE FILE PATHNAME:'
       read(*,1000)ipath
       open(icnc2,file=ipath,form='unformatted',status='old')
       call rdhdr(icnc2)
       if (icnc1f.ne.0) then
         WRITE(*,*)'ENTER 2ND FINE GRID FILE PATHNAME:'
         read(*,1000)ipath
         open(icnc2f,file=ipath,form='unformatted',status='old')
         call rdhdrf(icnc2f)
       endif
      ENDIF
c
c   set mapping of grid nests
c
      call fgmap
c
      WRITE(*,*)'ENTER NUMBER OF SPECIES TO EXTRACT:'
      read(*,1000)ipath
      READ(ipath,*)NVAR
c
      IF (NVAR .GT. MXSPC2 ) THEN
        WRITE(*,*)'*** ERROR IN XYSEC: NVAR GREATER THAN MXSPC',
     &             nvar,mxspc2
        stop
      ENDIF
      if (nvar.gt.1 .and. lsum) then
        write(*,*)'YOU CAN ONLY ENTER 1 DERIVED SPECIES'
        write(*,*)'WHEN SELECTING THE [SUM] OPTION'
        stop
      endif
c
      WRITE(*,1005)NVAR
      write(*,*)'ENTER SPECIES TO EXTRACT FROM AVERAGE FILE:'
c
      if (ltot .or. lsum) then
        do 111 l = 1,nvar
          do 111 i = 1,nxi
            do 111 j = 1,nyi
              do 111 k = 1,nzi
                cnc1(i,j,l,k)=0.
                cnc2(i,j,l,k)=0.
 111    continue
      else
        do 112 l = 1,nvar
          do 112 i = 1,nxi
            do 112 j = 1,nyi
              do 112 k = 1,nzi
                cnc1(i,j,l,k)=-999.
                cnc2(i,j,l,k)=-999.
 112    continue
      endif
c
      DO 100 L = 1,NVAR
        iunit(l)=-1
        read(*,1000)ipath
        read(ipath,1020)(MSPCW(M,L),M=1,10),lunit
        write(*,1020)(MSPCW(M,L),M=1,10),lunit
        LVAR1(L)=IDENT(MSPCW(1,L),MSPEC1,NOSPEC1)
        if (lvar1(l).eq.-9) then
          if (lsum) then
            write(*,*)'ENTER NUMBER OF SUB-SPECIES COMPRISING THIS'
            write(*,*)'DERIVED SPECIES'
            read(*,1000) ipath
            read(ipath,*) nsub
            write(*,*)'NUMBER OF SUB-SPECIES: ',nsub
            do 110 ls = 1,nsub
              write(*,*)'ENTER SPECIES TO EXTRACT FROM AVERAGE FILE'
              write(*,*)'AND A WEIGHTING FACTOR' 
              read(*,1000) ipath
              read(ipath,1021) (msub(m,ls),m=1,10),subfac(ls)
              write(*,1021) (msub(m,ls),m=1,10),subfac(ls)
              lsub(ls) = ident(msub(1,ls),mspec1,nospec1)
              if (lsub(ls).eq.-9) then
                 write(*,2010)(msub(m,ls),m=1,10)
                 stop8
              endif
  110       continue
          else 
            write(*,2010)(mspcw(m,l),m=1,10)
            stop8
          endif
        else
          if (lsum) then
            write(*,*)'YOU CANNOT SPECIFY A DERIVED SPECIES WITH'
            write(*,*)'THE SAME NAME AS A SPECIES ON FILE!'
             stop
          endif
        ENDIF
	lconv=.false.
        if (linst) then
          if (LUNIT(1:3).EQ.'PPM') then
            iunit(L)=1
          elseif (LUNIT(1:3).EQ.'PPB') then
            iunit(L)=2
          elseif (LUNIT(1:5).EQ.'UG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=7
          elseif (LUNIT(1:5).EQ.'NG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=8
          elseif (LUNIT(1:5).EQ.'PG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=9
          elseif (LUNIT(1:5).EQ.'FG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=10
          else
c           write(*,*)'UNITS MUST BE PPM OR PPB FOR ATDM INSTANT FILES!'
            write(*,*)'UNKNOWN UNITS !'
            stop
          endif
        elseif (ldepn) then
          if (LUNIT(1:5).EQ.'G/KM2') then
            iunit(L)=3
          elseif (LUNIT(1:6).EQ.'KG/KM2') then
            iunit(L)=4 
          elseif (LUNIT(1:5).EQ.'KG/HA') then
            iunit(L)=5 
          elseif (LUNIT(1:6).EQ.'MG/KM2') then
            iunit(L)=6 
          elseif (LUNIT(1:5).EQ.'UG/M2') then
            iunit(L)=11 
          else
            write(*,*)'UNITS MUST BE MG/KM2, G/KM2, KG/KM2, KG/HA'
            write(*,*)'FOR ATDM DEPOSITION FILES!'
            stop
          endif
        else
	 write(tststr,'(3a1)') (filnam(i),i=1,3)
	 if ( ifrst .or. (tststr .ne. airstr) ) then
          IF (LUNIT(1:5).EQ.'UG/M3') then
            iunit(L)=7
          elseif (LUNIT(1:5).EQ.'NG/M3') then
            iunit(L)=8
          elseif (LUNIT(1:5).EQ.'PG/M3') then
            iunit(L)=9
          elseif (LUNIT(1:5).EQ.'FG/M3') then
            iunit(L)=10
          elseif (LUNIT(1:3).EQ.'PPM' .and. ifrst) then
	    lconv=.true.
	    idir=1
            iunit(L)=1
          elseif (LUNIT(1:3).EQ.'PPB' .and. ifrst) then
	    lconv=.true.
	    idir=1
            iunit(L)=2
          elseif (LUNIT(1:3).EQ.'PPM' .and. .not. ifrst) then
	    lconv=.false.
            iunit(L)=1
          elseif (LUNIT(1:3).EQ.'PPB' .and. .not. ifrst) then
	    lconv=.false.
            iunit(L)=2
	  elseif (LUNIT(1:6).EQ.'NOUNIT') THEN
	    iunit(l)=1
	    lconv=.false.
          else
c            write(*,*)'UNITS MUST BE UG/M3, NG/M3, PG/M3 OR FG/M3',
c     &                ' FOR ATDM AVERAGE FILES!'
            write(*,*)'UNKNOWN UNITS !'
            stop
          endif
c
	 elseif ( tststr .eq. airstr ) then
c
          if (LUNIT(1:3).EQ.'PPM') then
            iunit(L)=1
          elseif (LUNIT(1:3).EQ.'PPB') then
            iunit(L)=2
          elseif (LUNIT(1:5).EQ.'UG/M3') then
            iunit(L)=7
          elseif (LUNIT(1:5).EQ.'NG/M3') then
            iunit(L)=8
          elseif (LUNIT(1:5).EQ.'PG/M3') then
            iunit(L)=9
          elseif (LUNIT(1:5).EQ.'FG/M3') then
            iunit(L)=10
          else
            write(*,*) 
     &            'UNITS MUST BE PPM OR PPB FOR ATDM AIRQUALITY FILES!'
            stop
          endif
c
	 endif
        endif
c
        IF(LDIF) THEN
          LVAR2(L)=IDENT(MSPCW(1,L),MSPEC2,NOSPEC2)
          if(lvar2(l).eq.-9) then
          write(*,2010)(mspcw(m,l),m=1,10)
           stop9
          ENDIF
        ENDIF
100   continue
c
      if ( .not. ifrst .and. lconv ) then
	  write(*,*) 'Unit conversions not allowed for extracted files!'
	  stop
      endif
      if ( lconv ) then
        write(*,*)'ENTER SURFACE-PRESSURE FILE PATHNAME:'
        read(*,1000)ipath
        write(*,1000)ipath
        open(irtp,file=ipath,form='unformatted',status='old')
c
        if ( .not. linst ) then
	   write(*,*) 'ENTER NUMBER OF VERTICAL LAYERS FOR MET DATA:'
	   read(*,1000) ipath
	   write(*,1000) ipath
	   read(ipath,*) nzrd
	endif
        write(*,*) 'ENTER MODEL TOP PRESSURE AND SIGMA VALUES :'
	read(*,1000) ipath
	write(*,1000) ipath
	read(ipath,*) ptop,(sig(k+1),k=1,nzrd)
	sig(1)=1.0
        write(*,*)
     $      'ENTER TEMPERATURE FILE PATHNAME:'
        read(*,1000)ipath
        write(*,1000)ipath
        open(idfb,file=ipath,form='unformatted',status='old')
        call gtvlvl(1)
      endif
c
      if (ldepn) then
        if ( ifrst ) then
         write(*,*)'ENTER WET, DRY OR BOTH FOR DEPOSITION TYPE'
         read(*,1000) ipath
         read(ipath,'(a4)') ndepn
         write(*,*) ndepn
         if (ndepn.ne.'WET '.and.ndepn.ne.'DRY '.and.
     &                                ndepn.ne.'BOTH') then
           write(*,*)'MUST SUPPLY WET, DRY, OR BOTH FOR DEPOSITION!'
           stop
         endif
	endif
        nlvl = 1
        level(nlvl) = 1
      else
        write(*,*)'ENTER NUMBER OF LEVELS TO EXTRACT AND'
        write(*,*)'LEVEL INDICES:'
        read(*,1000)ipath
        write(*,1000)ipath
        read(ipath,*)NLVL,(LEVEL(N),N=1,NLVL)
      endif
c
      write(*,*)'ENTER [SUB] TO PLOT A SUB-REGION, THE FIRST'
      write(*,*)'CELL INDICES AT WHICH TO START, AND THE LAST SET'
      write(*,*)'OF CELLS TO EXTRACT [IS1,JS1] [IS2,JS2]'
      read(*,1000)ipath
      write(*,1000)ipath
      IF(IPATH(1:3).eq.'SUB')THEN
      read(ipath,'(5x,4i5)')IS1,JS1,IS2,JS2
      write(*,*)'WRITING SUB-REGION TO OUTPUT FILE [IS1,JS1,IS2,JS2]:',
     &             IS1,JS1,IS2,JS2
c
c   redefine XORG,YORG,NX,NY, at this point to write to header later...
c
      XORG=XORG+FLOAT(IS1-1)*DXI
      YORG=YORG+FLOAT(JS1-1)*DYI
      lireg=.false.
      ELSEIF (ipath(1:3) .eq. 'IRR' ) then
      if ( icnc1f .ne. 0 ) then
	 write(*,*) ' Irregular domain not allowed with nested grids '
	 write(*,*) ' Extract nested grids first then extract', 
     &              ' irregular domain'
	 stop
      endif
      read(ipath,'(5x,a60)') fn
      open(iirg,file=fn,status='old')
      call readirg
      IS1 =1
      JS1 =1
      IS2=NXI
      JS2=NYI
      lireg=.true.
      close(iirg)
      ELSE
      IS1 =1
      JS1 =1
      IS2=NXI
      JS2=NYI
      lireg=.false.
      ENDIF
c
      write(*,*)'ENTER BEGINNING TIME AND DATE OF FIRST HOUR'
      write(*,*)'TO EXTRACT DATA:'
      read(*,1000)ipath
      read(ipath,*)tim1,idat1
      if(idat1.gt.99999)then
        call caltoj(idat1,jdat)
        idat1=jdat
      endif
      write(*,1030)TIM1,IDAT1
      write(*,*)'ENTER ENDING TIME AND DATE OF LAST HOUR'
      write(*,*)'TO EXTRACT DATA:'
      read(*,1000)ipath
      read(ipath,*)tim2,idat2
      if(idat2.gt.99999)then
        call caltoj(idat2,jdat)
        idat2=jdat
      endif
      write(*,1030)TIM2,IDAT2
c
      write(*,*)'ENTER PLOTTING INTERVAL IN HOURS:'
      read(*,1000)ipath
      write(*,1000)ipath
      read(ipath,*)PINTVL
      IF (LAVE ) PINTVL = 1.
c
c....Write UAM HEADER INFORMATION TO OUTPUT FILE
c
c    THE VARIABLE, NOTE, WILL CONTAIN:
c    1-2  CROSS SECTION TYPE
c    3-10  METHOD MAP, MAX, DIF, MXDIFF
c    11    NLVL  NUMBER OF LEVELS
c    12-...(LEVEL(N),N=1,NLVL) LEVEL INDICES
c    ?-? IX1,IX2,JY1,JY2
c         (IUNIT(L),L=1,NVAR)
c
      read(xystr,'(2a1)')(mnote(i),i=1,2)
      read(lans,'(8a1)')(mnote(i),i=3,10)
      note(11)=IS1
      note(12)=IS2
      note(13)=JS1
      note(14)=JS2
      do 300 k = 1,nlvl
        KK=14+K 
        note(KK)=level(k)
 300  continue
C
C....WRITE UNITS FOR EACH SPECIES
C
      DO 400 N = 1,NVAR
        KK=KK+1 
        NOTE(KK)=IUNIT(N)
 400  CONTINUE
c
      CALL WRTHDR
c
      TPLT=PINTVL
 10   if (icnc1f .gt. 0) then
        nn = id(0,lgrd,ngrd)
        if (nn .ge. 0) then
          call getz(ierr)
          if(ierr.eq.1)then
            write(*,*)'END OF COARSE GRID AVERAGE FILE.... EXITING'
            close(icnc1)
            close(ibnd)
            if(ldif)close(icnc2)
            close(iwr)
            return
          endif
        endif
        call getzf(ierr,deltat)
        if(ierr.eq.1)then
          write(*,*)'END OF FINE GRID AVERAGE FILE.... EXITING'
          close(icnc1f)
          close(ibnd)
          if(ldif)close(icnc2f)
          close(iwr)
          return
        endif
      else
        call getz(ierr)
        if(ierr.eq.1)then
          write(*,*)'END OF COARSE GRID AVERAGE FILE.... EXITING'
          close(icnc1)
          close(ibnd)
          if(ldif)close(icnc2)
          close(iwr)
          return
        endif
      endif
c
c  time checks modified by tcm, 10/21/92
c
      tchk = begtim + 24.*float(ibdat-idat1)
      if (tchk .lt. tim1) go to 10
C
       tchk = endtim + 24.*float(iedat-idat2) + .05
       if((lmax .or. ltot) .and. tchk .ge. tim2) then
        CALL WRTXY
        close(icnc1)
        close(ibnd)
        if(ldif)close(icnc2)
        close(iwr)
        return
       ENDIF
c
       IF(.NOT.LMAX .and. .NOT.LTOT) THEN
        if(tplt.eq.pintvl) then
          TPLT=1.
          call wrtxy
        else
          TPLT=TPLT+1.
        ENDIF
       ENDIF
       tchk = endtim + 24.*float(iedat-idat2) + .05
       if (tchk .ge. tim2) then
        IF( LAVE ) CALL GETAVE
          close(icnc1)
          close(ibnd)
          if(ldif)close(icnc2)
          close(iwr)
          return
       ENDIF
       goto 10

1000  format(20x,a)
1005  format(20x,i3)
1020  format(10a1,a8)
1021  format(10a1,f10.0)
1030  format(20x,f10.0,i10)
2000  format('[MAP]    N-HOURLY CONCENTRATION MAP',/,
     &       '[MAX]    MAXIMUM CONCENTRATION MAP',/,
     &       '[AVE]    N-HOUR AVERAGE CONCENTRATION MAP',/,
     &       '[DIF]    CONCENTRATION DIFFERENCE MAP',/,
     &       '[MXDIF]  MAXIMUM CONCENTRATION DIFERENCE MAP',/,
     &       '[TOT]    N-HOUR TOTAL MAP',/,
     &       '[SUM]    [MAP] FOR AN AGGREGATE SPECIES',/,
     &       '         ENTER SELECTION:',/,
     &       '------------------->')
2010   format('SPECIES NOT FOUND IN AVERAGE FILE!',10a1)
      end
