c---------------------------------------------------------------------c
c             ATDM POSTPROCESSING SYSTEM: EXTRACT                     c
c             11/20/95  CAE                                           c
c---------------------------------------------------------------------c
      subroutine xyvis
c
c     Produces a gridded visibility field from gridded PM concentrations
c     *** temporarily coded to handle coarse grid only
c         This program works on EXTRACTED files only!
c
      include 'xtract.inc'
      include 'xtract2.inc'
      include 'xtrvis.inc'
      character*80 ipath
      character*8 typstr,tststr(1)
      character*1 ifine
      data tststr/'MAP'/
      data eps /0.622/, e0 /6.11/, lv /2.5e6/, rv /461./
c 
      write(*,*)'ENTER XYSEC PATH NAME:'
      read(*,1000)ipath
      write(*,1000)ipath
      open(ird,file=ipath,form='unformatted',status='old')
c
      write(*,*)'ENTER OUTPUT VISMAP PATH NAME:'
      read(*,1000)ipath
      write(*,1000)ipath
      open(iwr,file=ipath,form='unformatted')
c
      write(*,*)'ENTER ATDM PRESSURE PATH NAME:'
      read(*,1000)ipath
      write(*,1000)ipath
      open(ipr,file=ipath,form='unformatted',status='old')
      write(*,*)'ENTER ATDM TEMPERATURE PATH NAME:'
      read(*,1000)ipath
      write(*,1000)ipath
      open(itp,file=ipath,form='unformatted',status='old')
      write(*,*)'ENTER ATDM HUMIDITY PATH NAME:'
      read(*,1000)ipath
      write(*,1000)ipath
      open(iqa,file=ipath,form='unformatted',status='old')
c
      write(*,*)'ENTER NX,NY,NZ, AND DELX,DELY FOR MET FILES:'
      read(*,1000) ipath
      read(ipath,*) nxlu,nylu,nzlu,dxlu,dylu
      write(*,*) nxlu,nylu,nzlu,dxlu,dylu
      write(*,*)'[C] COARSE OR [F] FINE FILE?'
      read(*,1000) ifine
      write(*,*) ifine
      if (ifine.eq.'F' .or. ifine.eq.'f') then
        write(*,*)'FINE GRID CAPABILITY NOT YET AVAILABLE'
        stop
      endif
c
      call rhdrvis
c
      if (abs(delx-dxlu).gt.0.001 .or. abs(dely-dylu).gt.0.001) then
        write(*,*)'MET RESOLUTION NOT EQUAL TO CONC FILE RESOLUTION!'
        write(*,*)'MET FILE: ',dxlu,dylu
        write(*,*)'CONC FILE: ',delx,dely
        stop
      endif
c
      do 20 n = 1,nvspc
        ll = idspc(name(n),spec,nvar)
        if (ll .le. 0 ) then
          write(*,*)'*** SPECIES NOT FOUND *** ',name(n)
          stop
        endif
  20  continue
c
      write(typstr,'(8a1)')(mnote(i),i=3,10)
      write(*,*) typstr
      is1=note(11)
      is2=note(12)
      js1=note(13)
      js2=note(14)
      do 30 n = 1,nz
       nn=n+14
       level(n)=note(nn)
  30  continue
      if (level(1).ne.1) then
         write(*,*)'THE INPUT EXTRACTED FILE DOES NOT CONTAIN LAYER 1'
         write(*,*)'VISIBILITY CAN ONLY BE CALCULATED FOR LAYER 1'
         write(*,*)'nz,level',nz,level
         stop
      endif
      nz = 1
c      write(*,*)'is1,is2,js1,js2,level'
c      write(*,*)is1,is2,js1,js2,level
c
      nnnx=is2-is1+1
      nnny=js2-js1+1
      if (nnnx .ne. nx .or. nnny .ne. ny) then
        xorg=xorg+float(is1-1)*delx
        yorg=yorg+float(js1-1)*dely
        nx = nnnx
        ny = nnny
      endif
      do 40 n = 1,nvar
        nn=nn+1
        iunit(n)=note(nn)
        if (iunit(n).eq.7) then
          fact(n) = 1.
        elseif (iunit(n).eq.8) then
          fact(n) = 1.e-3
        elseif (iunit(n).eq.9) then
          fact(n) = 1.e-6
        elseif (iunit(n).eq.10) then
          fact(n) = 1.e-9
        else
          write(*,*)'CONCENTRATIONS ARE IN WRONG UNITS'
          write(*,*)'IUNIT: ',iunit(n),spec(n)
          stop
        endif
  40  continue
c      write(*,*)'nvar,iunit'
c      write(*,*) nvar,iunit
c
      if (nx.gt.nxlu .or. ny.gt.nylu) then
        write(*,*)'MET FILES DO NOT CONTAIN ENOUGH CELLS!'
        write(*,*)'MET FILE: ',nxlu,nylu
        write(*,*)'CONC FILE: ',nx,ny
        stop
      endif
      if (is1.gt.nxlu .or. is2.gt.nxlu .or.
     &    js1.gt.nylu .or. js2.gt.nylu) then
        write(*,*)'STARTING AND/OR ENDING INDICES > NX OR NY!'
        write(*,*)'MET FILE: ',nxlu,nylu
        write(*,*)'CONC FILE: ',is1,is2,js1,js2
        stop
      endif
c 
c     ITYP = 1 MAP
c 
      ityp = -1
      do 50 l = 1,1
       if(tststr(l).eq.typstr) ityp = l
 50   continue
      if (ityp.lt.0) then
        write(*,*)'error reading method string: ',tststr
        write(*,*)'file must be labelled MAP'
        stop
      endif
c
      write(*,*)'ENTER BEGINNING TIME AND DATE OF FIRST HOUR'
      write(*,*)'TO EXTRACT DATA:'
      read(*,1000)ipath
      read(ipath,*)tim1,idat1
      if(idat1.gt.99999)then
        call caltoj(idat1,jdat)
        idat1=jdat
      endif
      write(*,1030)TIM1,IDAT1
      write(*,*)'ENTER ENDING TIME AND DATE OF LAST HOUR'
      write(*,*)'TO EXTRACT DATA:'
      read(*,1000)ipath
      read(ipath,*)tim2,idat2
      if(idat2.gt.99999)then
        call caltoj(idat2,jdat)
        idat2=jdat
      endif
      write(*,1030)TIM2,IDAT2
      write(*,*)'ENTER PLOTTING INTERVAL IN HOURS:'
      read(*,1000)ipath
      write(*,1000)ipath
      read(ipath,*)PINTVL
c
      write(*,*) ' XYVIS limprv :',limprv
      call whdrvis
c
      tplt = pintvl
 23   call rxyvis
      write(*,*)'READ DATA FOR PERIOD: ',begtim,ibdat,endtim,iedat
c
      tchk = begtim + 24.*float(ibdat-idat1)
      if (tchk.lt.tim1) go to 23
      if (tplt.ne.pintvl) then
        tplt = tplt + 1.
        goto 23
      endif
      tplt = 1.
c
c-----Read surface pressure file
c
  110 read(ipr,end=120) ttim,iidat,((psfc(i,j),i=1,nxlu),j=1,nylu)
      write(*,*)'Pressure file',ttim,iidat
      if (iidat .gt. 99999) then
	 call caltoj(iidat,jjdat)
	 iidat=jjdat
      endif
      if (ttim .ge. 100.) ttim=ttim/100. 
      if (iidat.lt.ibdat) go to 110
      if (iidat.eq.ibdat.and.(ttim+0.1).lt.begtim) go to 110
      if (iidat.ne.ibdat.or.abs(begtim-ttim).gt.1.0) then
        write(*,*)'Pressure file mismatch'
        write(*,*)ttim,iidat,ibdat,begtim
        stop
      endif
      goto 130
  120 write(*,*)'End of pressure file'
      stop
c
c-----Read temperature file
c
  130 read(itp,end=150) ttim,iidat
      do 140 k=1,nzlu
        read(itp,end=150) ttim,iidat,((temp(i,j,k),i=1,nxlu),j=1,nylu)
  140 continue
      write(*,*)'Temperature file',ttim,iidat
      if (iidat .gt. 99999) then
	 call caltoj(iidat,jjdat)
	 iidat=jjdat
      endif
      if (ttim .ge. 100.) ttim=ttim/100. 
      if (iidat.lt.ibdat) go to 130
      if (iidat.eq.ibdat.and.(ttim+0.1).lt.begtim) go to 130
      if (iidat.ne.ibdat.or.abs(begtim-ttim).gt.1.0) then
        write(*,*)'Temperature file mismatch'
        write(*,*)ttim,iidat,ibdat,begtim
        stop
      endif
      goto 160
  150 write(*,*)'End of temperature file'
      stop
c
c-----Read water vapor concentration file
c
  160 continue
      do 170 k=1,nzlu
        read(iqa,end=180) ttim,iidat,((qa(i,j,k),i=1,nxlu),j=1,nylu)
  170 continue
      write(*,*)'Humidity file',ttim,iidat
      if (iidat .gt. 99999) then
	 call caltoj(iidat,jjdat)
	 iidat=jjdat
      endif
      if (ttim .ge. 100.) ttim=ttim/100. 
      if (iidat.lt.ibdat) go to 160
      if (iidat.eq.ibdat.and.(ttim+0.1).lt.begtim) go to 160
      if (iidat.ne.ibdat.or.abs(begtim-ttim).gt.1.0) then
        write(*,*)'Humidity file mismatch'
        write(*,*)ttim,iidat,ibdat,begtim
        stop
      endif
      goto 190
  180 write(*,*)'End of temperature file'
      stop
c
c-----Calculate relative humidity
c
  190 continue
      do 200 j = 1,nylu
        do 200 i = 1,nxlu
          ev = qa(i,j,1)*psfc(i,j)/(qa(i,j,1) + eps)
          es = e0*exp((lv/rv)*(1./273. - 1./temp(i,j,1)))
          rh(i,j) = 100.*ev/es
  200 continue
c
      call visrng
c
      call wxyvis
      tchk = endtim + 24.*float(iedat-idat2) + .05
      if (tchk .ge. tim2) then
        close(ird)
        close(iwr)
        write(*,*)'EXITING XYVIS...'
        return
      endif
      goto 23 
1000  format(20x,a)
1030  format(20x,f10.0,i10)
1040  format(a)
      end
