c--------------------------------------------------------------------c
c          UPS-1 UAM POSTPROCESSING PACKAGE:   EXTRACT               c
c          VERSION 1.1                                               c
c--------------------------------------------------------------------c
      subroutine zsec
      include  'xtract.inc'
      include 'xtract2.inc'
      character*80 ipath
c
      write(*,*)'ENTER COARSE GRID CONCENTRATION FILE PATHNAME:'
      read(*,1000)ipath
      open(icnc1,file=ipath,form='unformatted',status='old')
      call rdhdr(icnc1)
c
      write(*,*)'ENTER FINE GRID FILE PATHNAME:'
      read(*,1000) ipath
      if(ipath.ne.' ')  then
        write(*,*)'OPENING FINE GRID FILE:',ipath
        open(icnc1f,file=ipath,form='unformatted',status='old')
        write(*,*)'ENTER NUMBER OF GRIDS TO USE (INCLUDING COARSE):'
        read(*,1000) ipath
        write(*,1000)ipath
        read(ipath,*) ngrd
        write(*,*)'ENTER GRID NUMBERS FROM WHICH TO EXTRACT (0=COARSE):'
        read(*,1000) ipath
        write(*,1000)ipath
        read(ipath,*,end=48) (lgrd(n),n=1,ngrd),deltat
	goto 49
 48     deltat=1.0
 49     call rdhdrf(icnc1f)

	do 491 nn=1,ngrd
	   if ( lgrd(nn) .le. 0 ) goto 491
	   ifn=lgrd(nn)
	   if ( ngrd .gt. 1 ) then
	     if ( nfz1(ifn) .ne. nz ) then
	       write(*,*) ' Multi-grid extractions with'
	       write(*,*) ' vertical nesting NOT SUPPORTED'
	       write(*,*) ' Extract vertical nested grids separately'
	       stop
	     endif
	     nzi=nz
     	     nxrd=nx
	     nyrd=ny
	     nzrd=nz
	   else
	     nzi=nfz1(ifn)
	     nxrd=nfx1(ifn)
	     nyrd=nfy1(ifn)
 	     nzrd=nfz1(ifn)
	   endif
 491    continue
      else
        icnc1f=0
        numfin1 = 0
        numfin2 = 0
	nxrd=nx
	nyrd=ny
	nzrd=nz
	ngrd=1
	lgrd(1)=0
	nzi=nz
      endif
c
c   if fine grids are included, find finest subdivision and determine
c   ultimate size of overall grid (this assumes that largest number
c   of subdivisions wrt coarse grid will work, but if we had one 
c   grid that was 3 and one that was 5 (e.g.) we would need lowest
c   common denominator (15).  The below would have to be changed
c   in that case)
c
      nhmax = 1
      if (icnc1f .ne. 0) then
        ncrs = id(0,lgrd,ngrd)
        if (ncrs .ge. 0) then
          do 50 nn=1,ngrd
	    if ( lgrd(nn) .eq. 0 ) goto 50
            ifine = lgrd(nn)
            if (nhf1(ifine) .gt. nhmax) nhmax = nhf1(ifine)
   50     continue
          nxi = nx*nhmax
          nyi = ny*nhmax
          dxi = delx/float(nhmax)
          dyi = dely/float(nhmax)
        else
          if1 = lgrd(1)
          do 55 nn=2,ngrd
            ifine = lgrd(nn)
            nhh = nhf1(ifine)/nhf1(if1)
            if (nhh .gt. nhmax) nhmax = nhh
   55     continue
          nxi = nfx1(if1)*nhmax
          nyi = nfy1(if1)*nhmax
          dxi = delfx1(if1)/float(nhmax)
          dyi = delfy1(if1)/float(nhmax)
        endif
      else
        nxi = nx
        nyi = ny
	nzi = nz
        dxi = delx
        dyi = dely
      endif
c
      IF ( NXI.GT.MXX.OR.NYI.GT.MXY.OR.NZI.GT.MXZ) THEN
        write(*,*)'*** ERROR-- GROWN GRID EXCEEDS ARRAY SIZE'
        WRITE(*,*)'            REDIMENSION MXX,MXY,MXZ',
     &          mxx,mxy,mxz,nxi,nyi,nzi
        stop1
      ENDIF
c
      write(*,*) ' nxi,nyi,nzi,dxi,dyi :',nxi,nyi,nzi,dxi,dyi
      write(*,*) ' nxrd,nyrd,nzrd :',nxrd,nyrd,nzrd
c
      write(*,*)'ENTER BOUNDARY FILE PATHNAME:'
      read(*,1000)ipath
      write(*,1000)ipath
      open(ibnd,file=ipath,form='unformatted',status='old')
      if (icnc1f .ne. 0 .and. ncrs .lt. 0) then
        if1 = lgrd(1)
	if ( ifrst ) then
           call rebnd(ibnd,mxy,nfx1(if1),nfy1(if1),ilft,irgt)
           call adjbnd(nhmax,nfx1(if1),nfy1(if1),ilft,irgt,
     $                   nxi,nyi,ilfti,irgti)
	endif
      else 
	if ( ifrst ) then
           call rebnd(ibnd,mxy,nx,ny,ilft,irgt)
           call adjbnd(nhmax,nx,ny,ilft,irgt,nxi,nyi,ilfti,irgti)
	endif
      endif
c
        write(*,*)'ENTER SURFACE-PRESSURE FILE PATHNAME:'
        read(*,1000)ipath
        write(*,1000)ipath
        open(irtp,file=ipath,form='unformatted',status='old')
c
        write(*,*) 'ENTER MODEL TOP PRESSURE AND SIGMA VALUES :'
	read(*,1000) ipath
	write(*,1000) ipath
	read(ipath,*) ptop,(sig(k+1),k=1,nzrd)
	sig(1)=1.0
        write(*,*)
     $      'ENTER TEMPERATURE FILE PATHNAME:'
        read(*,1000)ipath
        write(*,1000)ipath
        open(idfb,file=ipath,form='unformatted',status='old')
        call gtvlvl(1)
c
      write(*,*)'ENTER OUTPUT FILE PATHANME:'
      read(*,1000) ipath
      write(*,*)'OPENING OUTPUT FILE:',ipath
      open(iwr,file=ipath,form='unformatted')
c
      write(*,2000)
      read(*,1000)lans
      write(*,1000)lans
c
      LDIF = .FALSE.
      LMAX = .FALSE.
      LAVE = .FALSE.
      LTOT = .FALSE.
      LSUM = .FALSE.
      if(lans(1:3).eq.'SUM') then
       LSUM = .TRUE.
      endif
      if(lans(1:3).eq.'AVE') then
       LAVE=.TRUE.
      endif
      if(LANS(1:5).eq.'MXDIF')THEN
       LMAX=.TRUE.
       LDIF=.TRUE.
       WRITE(*,*)'ENTER 2ND COARSE GRID FILE PATHNAME:'
       read(*,1000)ipath
       open(icnc2,file=ipath,form='unformatted',status='old')
       call rdhdr(icnc2)
c
       if (icnc1f.ne.0) then
         WRITE(*,*)'ENTER 2ND FINE GRID FILE PATHNAME:'
         read(*,1000)ipath
         open(icnc2f,file=ipath,form='unformatted',status='old')
         call rdhdrf(icnc2f)
       endif
      ENDIF
      if(lans(1:3).eq.'MAX') THEN
       LMAX=.TRUE.
      ENDIF
      if(lans(1:3).eq.'TOT') THEN
       LTOT=.TRUE.
      ENDIF
      if(lans(1:3).eq.'DIF')THEN
       LDIF=.TRUE.
       WRITE(*,*)'ENTER 2ND COARSE FILE PATHNAME:'
       read(*,1000)ipath
       open(icnc2,file=ipath,form='unformatted',status='old')
       call rdhdr(icnc2)
       if (icnc1f.ne.0) then
         WRITE(*,*)'ENTER 2ND FINE GRID FILE PATHNAME:'
         read(*,1000)ipath
         open(icnc2f,file=ipath,form='unformatted',status='old')
         call rdhdrf(icnc2f)
       endif
      ENDIF
c
c   set mapping of grid nests
c
      call fgmap
c
      WRITE(*,*)'ENTER NUMBER OF SPECIES TO EXTRACT:'
      read(*,1000)ipath
      READ(ipath,*)NVAR
c
      IF (NVAR .GT. MXSPC2 ) THEN
        WRITE(*,*)'*** ERROR IN XYSEC: NVAR GREATER THAN MXSPC',
     &             nvar,mxspc2
        stop
      ENDIF
      if (nvar.gt.1 .and. lsum) then
        write(*,*)'YOU CAN ONLY ENTER 1 DERIVED SPECIES'
        write(*,*)'WHEN SELECTING THE [SUM] OPTION'
        stop
      endif
c
      WRITE(*,1005)NVAR
      write(*,*)'ENTER SPECIES TO EXTRACT FROM AVERAGE FILE:'
c
      if (ltot .or. lsum) then
        do 111 l = 1,nvar
          do 111 i = 1,nxi
            do 111 j = 1,nyi
              do 111 k = 1,nzi
                cnc1(i,j,l,k)=0.
                cnc2(i,j,l,k)=0.
 111    continue
      else
        do 112 l = 1,nvar
          do 112 i = 1,nxi
            do 112 j = 1,nyi
              do 112 k = 1,nzi
                cnc1(i,j,l,k)=-999.
                cnc2(i,j,l,k)=-999.
 112    continue
      endif
c
      DO 100 L = 1,NVAR
        iunit(l)=-1
        read(*,1000)ipath
        read(ipath,1040)(MSPCW(M,L),M=1,10),lunit
        write(*,1040)(MSPCW(M,L),M=1,10),lunit
        LVAR1(L)=IDENT(MSPCW(1,L),MSPEC1,NOSPEC1)
        if (lvar1(l).eq.-9) then
          if (lsum) then
            write(*,*)'ENTER NUMBER OF SUB-SPECIES COMPRISING THIS'
            write(*,*)'DERIVED SPECIES'
            read(*,1000) ipath
            read(ipath,*) nsub
            write(*,*)'NUMBER OF SUB-SPECIES: ',nsub
            do 110 ls = 1,nsub
              write(*,*)'ENTER SPECIES TO EXTRACT FROM AVERAGE FILE'
              write(*,*)'AND A WEIGHTING FACTOR' 
              read(*,1000) ipath
              read(ipath,1021) (msub(m,ls),m=1,10),subfac(ls)
              write(*,1021) (msub(m,ls),m=1,10),subfac(ls)
              lsub(ls) = ident(msub(1,ls),mspec1,nospec1)
              if (lsub(ls).eq.-9) then
                 write(*,2010)(msub(m,ls),m=1,10)
                 stop8
              endif
  110       continue
          else 
            write(*,2010)(mspcw(m,l),m=1,10)
            stop8
          endif
        else
          if (lsum) then
            write(*,*)'YOU CANNOT SPECIFY A DERIVED SPECIES WITH'
            write(*,*)'THE SAME NAME AS A SPECIES ON FILE!'
             stop
          endif
        ENDIF
	lconv=.false.
        if (linst) then
          if (LUNIT(1:3).EQ.'PPM') then
            iunit(L)=1
          elseif (LUNIT(1:3).EQ.'PPB') then
            iunit(L)=2
          elseif (LUNIT(1:5).EQ.'UG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=7
          elseif (LUNIT(1:5).EQ.'NG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=8
          elseif (LUNIT(1:5).EQ.'PG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=9
          elseif (LUNIT(1:5).EQ.'FG/M3' .and. ifrst) then
	    lconv=.true.
	    idir=0
            iunit(L)=10
          else
c           write(*,*)'UNITS MUST BE PPM OR PPB FOR ATDM INSTANT FILES!'
            write(*,*)'UNKNOWN UNITS !'
            stop
          endif
        else
	  write(*,*) ' Input file must be INSTANT ...!'
	  stop
	endif
c
        IF(LDIF) THEN
          LVAR2(L)=IDENT(MSPCW(1,L),MSPEC2,NOSPEC2)
          if(lvar2(l).eq.-9) then
          write(*,2010)(mspcw(m,l),m=1,10)
           stop9
          ENDIF
        ENDIF
100   continue
c
      if ( .not. ifrst .and. lconv ) then
	  write(*,*) 'Unit conversions not allowed for extrcted files!'
	  stop
      endif
c
      write(*,*)'ENTER BEGINNING TIME AND DATE:'
      read(*,1000)ipath
      read(ipath,*)tim1,idat1
       if(idat1.gt.99999)then
         call caltoj(idat1,jdat)
         idat1=jdat
       endif
      tim1=aint(tim1+0.01)
      write(*,1010)tim1,idat1
c
      write(*,*)'ENTER ENDING TIME AND DATE:'
      read(*,1000)ipath
      read(ipath,*)tim2,idat2
       if(idat2.gt.99999)then
         call caltoj(idat2,jdat)
         idat2=jdat
       endif
      tim2=aint(tim2+0.01)
      write(*,1010)tim2,idat2
c
      write(*,*)'ENTER PLOTTING INTERVAL IN HOURS:'
      read(*,1000)ipath
      write(*,1000)ipath
      read(ipath,*)pintvl
c
      write(*,*)'ENTER THE NUMBER OF CROSS SECTIONS TO BE EXTRACTED:'
      read(*,1000)ipath
      READ(ipath,*)NSEC
      write(*,1005)NSEC
      IF(NSEC.gt.mxsec) then
        write(*,*)'NSEC IS GREATER THAN THE MAXIMUM NUMBER: ',MXSEC
        stop
      endif
      DO 200 N = 1,NSEC
        write(*,*)'ENTER BEGINNING CELL COORDINATES [IX1,JX1,KZ1]:'
        read(*,1000)ipath
        write(*,1000)ipath
        read(ipath,*)ix1(n),jy1(n),kz1(n)
        write(*,*)'ENTER ENDING CELL COORDINATES    [IX2,JX2,KZ2]:'
        read(*,1000)ipath
        write(*,1000)ipath
        read(ipath,*)ix2(n),jy2(n),kz2(n)
        IF(JY1(N).NE.JY2(N) .AND. IX1(N).NE.IX2(N)) THEN
         WRITE(*,*)'CROSS SECTION MUST BE TWO-DIMENSIONAL!'
         STOP2
        ENDIF
 200  CONTINUE
c
c.... WRITE ZSEC FILE HEADER
c
       if ( iutm .lt. 0 ) then
	  xorg=xorg*1000.
	  yorg=yorg*1000.
	  dxi=dxi*1000.
	  dyi=dyi*1000.
       endif
       write(iwr) xorg, yorg,dxi,dyi,nvar,nsec,iutm,
     &           idat1,tim1,idat2,tim2
       write(iwr)((mspcw(m,l),m=1,10),l=1,nvar)
       write(iwr)(iunit(L),l=1,nvar)
       write(iwr)(ix1(n),ix2(n),jy1(n),jy2(n),kz1(n),kz2(n),n=1,nsec)
c
c      LOAD LEVEL ARRAY SO THAT GETZ WILL EXTRACT EVERY LEVEL
c
      nlvl=nzi
      do 250 k = 1,nzi
        level(k)=k
 250  continue
c
      tplt=pintvl
   23 if (icnc1f .gt. 0) then
        nn = id(0,lgrd,ngrd)
        if (nn .ge. 0) then
          call getz(ierr)
          if(ierr.eq.1)then
            write(*,*)'END OF COARSE GRID AVERAGE FILE.... EXITING'
            close(icnc1)
            close(ibnd)
            if(ldif)close(icnc2)
            close(iwr)
            close(irtp)
            close(idfb)
            return
          endif
        endif
        call getzf(ierr,deltat)
        if(ierr.eq.1)then
          write(*,*)'END OF FINE GRID AVERAGE FILE.... EXITING'
          close(icnc1)
          close(ibnd)
          if(ldif)close(icnc2)
          close(iwr)
          close(irtp)
          close(idfb)
          return
        endif
      else
        call getz(ierr)
        if(ierr.eq.1)then
          write(*,*)'END OF COARSE GRID AVERAGE FILE.... EXITING'
          close(icnc1)
          close(ibnd)
          if(ldif)close(icnc2)
          close(iwr)
          close(irtp)
          close(idfb)
          return
        endif
      endif
      tchk = begtim + 24.*float(ibdat-idat1)
      if (tchk .lt. tim1) go to 23
c
c       GET UAM LEVELS AND WRITE TO OUTPUT FILE
c
      if(tplt.eq.pintvl) then
        call wrtz
        tplt=1.
      ELSE
       tplt=tplt+1.
      ENDIF
c
      tchk = endtim + 24.*float(iedat-idat2)
      if (tchk .lt. tim2) go to 23
      write(*,*)'EXITING ZSEC' 
      close(icnc1)
      close(ibnd)
      close(iwr)
      if(ldif)close(icnc2)
      close(irtp)
      close(idfb)
      return
1000  format(20x,a)
1010  format(20x,f10.0,i10)
1030  FORMAT(20x,10A1)
1050  format(10a1)
1005  FORMAT(20x,i2)
1020  format(20x,2i10)
1025  format(18x,f10.0)
1028  format('FILE#1:SPECIES: ',10a1,' WILL BE MULTIPLIED BY: ',
     &      1pe12.3,'TOTAL FACTOR: ',1pe12.3)
1029  format('FILE#2:SPECIES: ',10a1,' WILL BE MULTIPLIED BY: ',
     &      1pe12.3,'TOTAL FACTOR: ',1pe12.3)
1040  format(10a1,a8)
2010   format('SPECIES NOT FOUND IN AVERAGE FILE!',10a1)
1021  format(10a1,f10.0)
2000  format('[MAP]    ISOPLETH FILE',/,
     &       '[MAX]    MAXIMUM CONCENTRATION FILE',/,
     &       '[DIF]    CONCENTRATION DIFFERENCE FILE',/,
     &       '[MXDIF] MAXIMUM CONCENTRATION DIFFERENCE FILE',/,
     &       '         ENTER SELECTION:',/,
     &       '------------------->')
       end
