      SUBROUTINE FLEMRD (IPRINT, INFILE, NAMLEN, NVARBL,
     $    NXCELL, NYCELL, KSGMT, MVARBL, OUTMAT, JFLAG)
C
C NAME -- EMISSIONS FILE RECORD READ
C
C DESCRIPTION -- READS THE TIME-VARIANT EMISSIONS FILE RECORDS
C         FOR ALL VARIABLES IN ONE SEGMENT
C
C PROGRAMMER -- DC WHITNEY /SAI JULY 1977
C
C INPUTS --
C         IPRINT    I  FORTRAN OUTPUT UNIT
C         INFILE    I  FORTRAN INPUT FILE UNIT
C         NAMLEN    I  NUMBER OF WORDS IN A NAME
C         NVARBL    I  NUMBER OF VARIABLES
C         NXCELL    I  NUMBER OF X-CELLS
C         NYCELL    I  NUMBER OF Y-CELLS
C         KSGMT     I  SEGMENT NUMBER
C         MVARBL    I  VARIABLE NAMES
C         OUTMAT    R  THE OUTPUT VALUE MATRIX
C
C OUTPUTS --
C         JFLAG     I  COMPLETION FLAG
C
C LOCAL VARIABLES -- NONE
C
C ROUTINES CALLED -- NONE
C
C ERROR CONDITIONS --
C         -6        ERROR IN SYSTEM READ ROUTINE
C
C OTHER INFORMATION --
C
C
C
C SET DIMENSIONS OF EXTERNAL ARRAYS
C
Ctcm  DIMENSION MVARBL(NAMLEN,NVARBL)
      character*4 MVARBL(NAMLEN,NVARBL)
      DIMENSION OUTMAT(NXCELL, NYCELL, NVARBL)
C
C SET COMPLETION FLAG TO INITIAL VALUE
C
      JFLAG = 0
C
C SET A LOOP OVER ALL VARIABLES
C
      DO 100 N = 1,NVARBL
C
C READ THE EMISSIONS RECORD
C
         READ (INFILE) KSGMT, (MVARBL(I,N), I = 1, NAMLEN),
     $         ((OUTMAT(I,J,N), I = 1, NXCELL), J = 1, NYCELL)
C
C CHECK FOR ERROR ON READ, END LOOP, AND RETURN
C
         IF (JFLAG .NE. 0) GO TO 930
  100 CONTINUE
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR ON RECORD READ FROM FILE
C
  930 WRITE (IPRINT, 2930) JFLAG
      JFLAG = -6
      GO TO 1000
C
C RETURN TO CALLING ROUTINE
C
 1000 RETURN
C
C FORMATS
C
 2930 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        44H RETURNED TO FLEMRD FROM SYSTEM READ ROUTINE, //)
      END
