      SUBROUTINE FLRGRD (IPRINT, INFILE, NXCELL, NYCELL, NZCELL, NZLOWR,
     $   NZUPPR, JUTMZN, XUTMOR, YUTMOR, XREGOR, YREGOR, XCELLD, YCELLD,
     $   ZHTSUR, ZMINLW, ZMINUP, JFLAG)
C
C NAME -- FILE REGION READ
C
C DESCRIPTION -- READS THE FILE REGION AT THE BEGINNING OF
C         EVERY FILE
C
C PROGRAMMER -- DC WHITNEY /SAI JULY 1977
C
C INPUTS --
C         IPRINT    I  FORTRAN OUTPUT UNIT
C         INFILE    I  FORTRAN INPUT FILE UNIT
C
C OUTPUTS --
C         JFLAG     I  COMPLETION FLAG
C
C LOCAL VARIABLES -- NONE
C
C ROUTINES CALLED -- NONE
C
C ERROR CONDITIONS --
C         -1        ERROR IN SYSTEM READ ROUTINE
C
C OTHER INFORMATION --
C
C
C
C SET COMPLETION FLAG TO INITIAL VALUE
C
      JFLAG = 0
C
C READ THE FILE REGION RECORD
C
      READ (INFILE) XUTMOR, YUTMOR, JUTMZN, XREGOR, YREGOR, XCELLD,
     $              YCELLD, NXCELL, NYCELL, NZCELL, NZLOWR,
     $              NZUPPR, ZHTSUR, ZMINLW, ZMINUP
C
C CHECK FOR ERROR ON READ, ELSE RETURN
C
      IF (JFLAG .NE. 0) GO TO 905
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR ON READ
C
  905 WRITE (IPRINT, 2905) JFLAG
      JFLAG = -1
      GO TO 1000
C
C RETURN TO CALLING RETURN
C
 1000 RETURN
C
C FORMATS
C
 2905 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        44H RETURNED TO FLRGRD FROM SYSTEM READ ROUTINE, //)
      END
