c
c  prepares a file giving latitude/longitude of the center of each
c  grid cell of a Lambert conformal grid for use in the REMSAD model
c  (10/15/01, tcm)
c
      character proj*2
      character*80 ipath
      include 'xyllon.inc'
      include 'lamstf.inc'
      data proj /'LC'/
c
c  030402 - tcm - corrected definition of imax and jmax for 
c                 consistency with the use of j,i in the conversion
c                 subroutine xytoll.
c
      read(*,'(20x,a)') ipath
      read(ipath,*)grds,clat,clon,fsp,ssp
      call lccone(fsp,ssp,1)
      read(*,'(20x,a)') ipath
      read(ipath,*)xo, yo, nx, ny
c
c  note that j goes with x and i goes with y for consistency
c  with the use of j,i in the conversion subroutine.c
c
      jmax = nint(-xo/grds)*2
      imax = nint(-yo/grds)*2
      read(*,'(20x,a)') ipath
      read(ipath,*)xx, yy
      call xytoll (xx,yy,ylat,xlon,proj)
      write(*,*) xx,yy,xlon,ylat
      read(*,'(20x,a)') ipath
      read(ipath,*)xk, yk
      xx = (xk-xo)/grds
      yy = (yk-yo)/grds
      call xytoll (xx,yy,ylat,xlon,proj)
      write(*,*) xx,yy,xlon,ylat
      do j=1,ny
        do i=1,nx
          xx = float(i-1) + .5
          yy = float(j-1) + .5
          call xytoll (xx,yy,ylat,xlon,proj)
          write(8,*) i,j,xlon,ylat
        enddo
      enddo
      stop
      end
