C     PROGRAM PTSRCE(INPUT, OUTPUT, TAPE5=INPUT, TAPE6=OUTPUT,
C    $     TAPE11, TAPE12, TAPE14, TAPE15, TAPE16, TAPE25)
C   *************************************************************
C
C     PROGRAM DEVELOPED BY:
C
C             SYSTEMS APPLICATIONS, INC.
C             101 LUCAS VALLEY ROAD
C             SAN RAFAEL, CALIFORNIA  94903
C                     (415)-472-4011
C
C   *************************************************************
C NOTE --  REMOVE COMMENT ON 25150  DMB (10/23/86)
C
C NAME -- POINT SOURCE
C
C DESCRIPTION -- DATA PREPARATION PROGRAM FOR THE PRODUCTION OF THE
C         POINT SOURCE FILE
C
C PROGRAMMER -- DC WHITNEY, SAI, JULY 1977
C
C  MODIFIED -- TC MYERS - NOVEMBER 1981 - TO USE STACK HEIGHT WIND SPEED
C                                         AND STP HEAT CAPACITY AND
C                                         DENSITY OF AIR IN PLUME RISE
C                                         CALCULATIONS
C  MODIFIED 12/6/85 (KKW)
C    STATEMENT AT 2588 COMMENTED OUT TO ALLOW FLOW THROUGH THE FOLLOWING
C    DO LOOP USING FORTRAN 77
C
C
C  MODIFIED 10/22/86 (DMB)
C    1. BINARY SEARCH - DHSRCH - USED TO FIND POINT SOURCE NAME AT
C          25540 -       IN SUBROUTINE PSEMRD
C
C    2. REWIND OF INPUT FILES AT 18760 TO 18810 REMOVED
C
C    3. SUBROUTINE TMPSRD IN B9.UTILITY (READ OF TEMPERATURE FILE)
C          MODIFIED TO HANDLE MULTIPLE DAYS
C
C    4. IF NO VERTICAL PARAMETERS (NVPARM = 0) NVPARM SET TO 1 SO ARRAY
C        MVPARM(NAMLEN,NVPARM) PASSED CORRECTLY FOR FORTRAN 77 TO PTSPRC
C        (LINE 6180)
C
C    5.  CALL TO ERRSET REMOVED
C
C  MODIFIED 10/28/86 (PDA)
C
C    1.  SUBROUTINE PLMRIS CHANGED TO ASSUME ACTUAL VOLUMETRIC FLOW
C           RATHER THAN STP, AND WILL COMPUTE FLOWRATE FROM VELOCITY AND
C           DIAMETER IF FLOWRATE IS .LE. 0.0
C
C  MODIFIED 10/31/86 (DMB)
C    1. BINARY SEARCH - SEARCH - REWRITTEN IN FORTRAN AS SUBROUTINE
C          48850 - 49300  SUBROUTINE SEARCH
C
C  MODIFIED 11/3/86 (PDA)
C    1. PLUME RISE DATA WRITTEN TO UNIT 2 STARTING AT 18451 IN
C       SUBROUTINE PLMRIS
C
C  MODIFIED TO SET DEFAULTS FOR DIFBRK AND REGTOP WHEN FILES ARE
C  MISSING.  ADDED VERSION NUMBER.  (TCM, 9/14/92)
C
C LOCAL VARIABLES --
C         INCARD     I  INPUT UNIT
C         IPRINT     I  OUTPUT UNIT
C         IPTSRC     I  OUTPUT FILE NUMBER
C         IDFBRK     I  DIFFUSION BREAK FILE NUMBER
C         IRGTOP     I  REGION TOP FILE NUMBER
C         ITEMPS     I  TEMPERATURE FILE NUMBER
C         IMETSC     I  METEOROLOGICAL SCALARS FILE NUMBER
C         IWINDS     I  WIND FILE NUMBER
C         KVBNM      I  START OF VARIABLE NAMES IN SCRATCH
C         KUNNM      I  START OF UNIT NAME IN SCRATCH
C         KMULT      I  START OF MULTIPLICATIVE FACTOR IN SCRATCH
C         KADTV      I  START OF ADDITIVE FACTOR IN SCRATCH
C         KMOLW      I  START OF MOLECULAR WEIGHT IN SCRATCH
C         KPSNM      I  START OF POINT SOURCE NAMES IN SCRATCH
C         KPTNM      I  START OF POINT SOURCE TYPE NAMES IN SCRATCH
C         KPSXL      I  START OF POINT SOURCE X-LOCATION IN SCRATCH
C         KPSYL      I  START OF POINT SOURCE Y-LOCATION IN SCRATCH
C         KPSTP      I  START OF POINT SOURCE TYPES IN SCRATCH
C         KPSEV      I  START OF POINT SOURCE EMISSIONS VALUES IN SCRATC
C         KPSEF      I  START OF POINT SOURCE EMISSIONS FACTORS IN SCRAT
C         KMTHN      I  START OF METHOD NUMBERS IN SCRATCH
C         KMINV      I  START OF METHOD MINIMUM VALUES IN SCRATCH
C         KMAXV      I  START OF METHOD MAXIMUM VALUES IN SCRATCH
C         KPRMP      I  START OF METHOD PARAMETER POINTERS IN SCRATCH
C         KPRMC      I  START OF METHOD PARAMETER COUNTERS IN SCRATCH
C         KPRNM      I  START OF METHOD PARAMETER NAMES IN SCRATCH
C         KPRMV      I  START OF METHOD PARAMETER VALUES IN SCRATCH
C         KVMTN      I  START OF VERTICAL METHOD NUMBER IN SCRATCH
C         KVMNV      I  START OF VERTICAL METHOD MINIMUM VALUES IN SCRAT
C         KVMXV      I  START OF VERTICAL METHOD MAXIMUM VALUES IN SCRAT
C         KVPRP      I  START OF VERTICAL METHOD PARAMETER POINTERS IN S
C         KVPRC      I  START OF VERTICAL METHOD PARAMETER COUNTERS IN S
C         KVPNM      I  START OF VERTICAL METHOD PARAMETER NAMES IN SCRA
C         KVPRV      I  START OF VERTICAL METHOD PARAMETER VALUES IN SCR
C         KPSSH      I  START OF POINT SOURCE STACK HEIGHT IN SCRATCH
C         KPSSD      I  START OF POINT SOURCE STACK DIAMETER IN SCRATCH
C         KPSST      I  START OF POINT SOURCE STACK TEMPERATURE IN SCRAT
C         KPSSV      I  START OF POINT SOURCE STACK VELOCITY IN SCRATCH
C         KDFBK      I  START OF DIFFUSION BREAK IN SCRATCH
C         KRGTP      I  START OF REGION TOP IN SCRATCH
C         KTMPS      I  START OF TEMPERATURE IN SCRATCH
C         KMTSC      I  START OF METEOROLOGICAL SCALARS IN SCRATCH
C         KWNDU      I  START OF WIND U-VECTOR IN SCRATCH
C         KWNDV      I  START OF WIND V-VECTOR IN SCRATCH
C         KPGRD      I  START OF POINT SOURCE LOCATION GRID
C         KPSXC      I  START OF POINT SOURCE X-CELL LOCATION IN SCRATCH
C         KPSYC      I  START OF POINT SOURCE Y-CELL LOCATION IN SCRATCH
C         KPSZC      I  START OF POINT SOURCE Z-CELL LOCATION IN SCRATCH
C         KPSPH      I  START OF POINT SOURCE PLUME HEIGHT IN SCRATCH
C         KPSFR      I  START OF POINT SOURCE FLOW RATE IN SCRATCH
C         KPSFX      I  START OF POINT SOURCE EMISSIONS FLUX IN SCRATCH
C         KSPTR      I  START OF RESIDUAL SCRATCH STORAGE
C         LINPTP     I  PRINT FLAG FOR INPUT CARD
C         LPSEGP     I  PRINT FLAG FOR OUTPUT GRID TABLE
C         LPGRDP     I  PRINT FLAG FOR OUTPUT GRID
C         LUNITP     I  PRINT FLAG FOR UNITS TABLE
C         LPSLTP     I  PRINT FLAG FOR POINT SOURCE LOCATION TABLE
C         LPSLGP     I  PRINT FLAG FOR POINT SOURCE LOCATION GRID
C         LMTHDP     I  PRINT FLAG FOR METHOD TABLE
C         LPSRDP     I  PRINT FLAG FOR POINT SOURCE READINGS
C         LVMTHP     I  PRINT FLAG FOR VERTICAL METHOD TABLE
C         NAMLEN     I  NAME LENGTH
C         NIDLEN     I  IDENTIFICATION FIELD LENGTH
C         NSGMNT     I  NUMBER OF SEGMENTS
C         NOPTIN     I  NUMBER OF CONTROL OPTIONS
C         NINVAR     I  NUMBER OF INTRINSIC VARIABLES
C         NSPECS     I  NUMBER OF SPECIES
C         NUSVAR     I  NUMBER OF USER-DEFINED VARIABLES
C         NUNVAR     I  NUMBER OF UNIT-ONLY VARIABLES
C         NVARBL     I  TOTAL NUMBER OF VARIABLES
C         NUNITS     I  NUMBER OF UNITS
C         NSTATS     I  NUMBER OF POINT SOURCES
C         NBLINE     I  NUMBER OF BOUNDARY LINES
C         NPTSRC     I  NUMBER OF POINT SOURCES
C         NPTSRT     I  NUMBER OF POINT SOURCE TYPES
C         NMETHD     I  NUMBER OF METHODS
C         NPARAM     I  NUMBER OF PARAMETERS
C         NVMETH     I  NUMBER OF VERTICAL METHODS
C         NVPARM     I  NUMBER OF VERTICAL PARAMETERS
C         NPRFHT     I  NUMBER OF PROFILE HEIGHTS
C         NMETSC     I  NUMBER OF METEOROLOGICAL SCALARS
C         NINFIL     I  NUMBER OF INPUT FILES
C         NSCRTC     I  MAXIMUM AVAILABLE SCRATCH
C         NSCPTR     I  NUMBER OF DIMENSIONED VARIABLE POINTERS TO SCRAT
C         NXCELL     I  NUMBER OF CELLS IN X-DIRECTION
C         NYCELL     I  NUMBER OF CELLS IN Y-DIRECTION
C         NZCELL     I  NUMBER OF CELLS IN Z-DIRECTION
C         NZLOWR     I  NUMBER OF CELLS IN LOWER VERTICAL LAYER
C         NZUPPR     I  NUMBER OF CELLS IN UPPER VERTICAL LAYER
C         NWORDS     I  NUMBER OF WORDS IN AN ARRAY
C         NSCLFT     I  NUMBER OF WORDS LEFT IN SCRATCH
C         JBEGDT     I  BEGINNING DATE
C         JENDDT     I  ENDING DATE
C         JUTMZN     I  UTM ZONE NUMBER
C         JXSGOR     I  X-COORDINATE OF SEGMENT ORIGIN IN REGION
C         JYSGOR     I  Y-COORDINATE OF SEGMENT ORIGIN IN REGION
C         JMISSV     I  MISSING INTEGER VALUE
C         BEGTIM     R  BEGINNING TIME
C         ENDTIM     R  ENDING TIME
C         XUTMOR     R  X-COORDINATE OF UTM ORIGIN
C         YUTMOR     R  Y-COORDINATE OF UTM ORIGIN
C         XREGOR     R  X-COORDINATE OF REGION ORIGIN
C         YREGOR     R  Y-COORDINATE OF REGION ORIGIN
C         XCELLD     R  LENGTH OF CELL IN X-DIRECTION
C         YCELLD     R  LENGTH OF CELL IN Y-DIRECTION
C         ZHTSUR     R  CELL HEIGHT, SURFACE LAYER
C         ZMINLW     R  MINIMUM CELL HEIGHT, LOWER LAYER
C         ZMINUP     R  MINIMUM CELL HEIGHT, UPPER LAYER
C         RMISSV     R  MISSING REAL VALUE
C         INFILE     I  FILE UNIT NUMBERS
C         MFILNM     I  FILE NAME
C         MFILID     I  FILE IDENTIFICATION
C         MUNVAR     I  UNIT-ONLY VARIABLE NAMES
C         LPRINT     I  PRINT FLAGS
C         JOPTIN     I  CONTROL OPTIONS
C         JSTKPT     I  VECTOR OF POINTERS FOR STACK PARAMETERS
C         JSCRTC     I  SCRATCH FOR PARTITIONING
C         JSCPTR     I  POINTERS TO EACH DIMENSIONED VARIABLE IN SCRATCH
C         JINTSC     I  INTEGER SCALARS FOR PASSING TO PROCESSING ROUTIN
C         REALSC     R  REAL SCALARS FOR PASSING TO PROCESSING ROUTINE
C         JFLAG      I  COMPLETION FLAG
C         IFILES     I  UNIT NUMBER TO READ BINARY FILE NAMES FROM
C
C ROUTINES CALLED --
C         CNTLRD     CONTROL PACKET READ
C         REGNRD     REGION PACKET READ
C         FLHDWR     FILE HEADER WRITE
C         FLRGWR     FILE REGION WRITE
C         FLSGWR     FILE SEGMENT WRITE
C         FLSPWR     FILE SPECIES WRITE
C         FLHDCK     FILE HEADER CHECK
C         SCRPRC     SCRATCH PARTITION
C         PTSPRC     POINT SOURCE PROCESS
C
C ERROR CONDITIONS --
C
C          -1   NEGATIVE ERROR FLAG FROM CONTROL READ SUBROUTINE
C          -2   NONPOSITIVE SPECIES COUNT
C          -3   NEGATIVE ERROR FLAG FROM REGION READ SUBROUTINE
C          -4   INSUFFICIENT NUMBER OF VERTICAL CELLS
C          -5   NEGATIVE ERROR FLAG FROM FILE HEADER VERIFICATION
C               SUBROUTINE FOR DIFFUSION BREAK
C          -6   NEGATIVE ERROR FLAG FROM FILE HEADER VERIFICATION
C               SUBROUTINE FOR REGION TOP
C          -8   NEGATIVE ERROR FLAG FROM FILE HEADER VERIFICATION
C               SUBROUTINE FOR TEMPERATURE
C          -9   NEGATIVE ERROR FLAG FROM FILE HEADER VERIFICATION
C               SUBROUTINE FOR METEOROLOGICAL SCALARS
C          -10  NEGATIVE ERROR FLAG FROM FILE HEADER VERIFICATION
C               SUBROUTINE FOR WIND
C          -11  NEGATIVE ERROR FLAG FROM FILE HEADER WRITE SUBROUTINE
C          -12  NEGATIVE ERROR FLAG FROM FILE REGION WRITE SUBROUTINE
C          -13  NEGATIVE ERROR FLAG FROM FILE SEGMENT DESCRIPTION
C               WRITE SUBROUTINE
C          -14  NEGATIVE ERROR FLAG FROM FILE SPECIES WRITE SUBROUTINE
C          -15  NEGATIVE ERROR FLAG FROM SCRATCH PARTITION SUBROUTINE
C          -16  NEGATIVE ERROR FLAG FROM POINT SOURCE PROCESS SUBROUTINE
C
C OTHER INFORMATION --
C
C
C
C DECLARE THE PRINT FLAG ARRAY AND ITS MEMBERS
C
      LOGICAL LPRINT
      LOGICAL LINPTP
      LOGICAL LPSEGP
      LOGICAL LUNITP
      LOGICAL LPSLTP
      LOGICAL LPSLGP
      LOGICAL LMTHDP
      LOGICAL LPSRDP
      LOGICAL LVMTHP
      LOGICAL LPGRDP
C
C SET ARRAY SIZES
C
Ctcm  DIMENSION MFILNM(10)
      character*4 MFILNM(10)
Ctcm  DIMENSION MDIFBK(10)
      character*4 MDIFBK(10)
Ctcm  DIMENSION MTEMPS(10)
      character*4 MTEMPS(10)
Ctcm  DIMENSION MREGTP(10)
      character*4 MREGTP(10)
Ctcm  DIMENSION MMETSC(10)
      character*4 MMETSC(10)
Ctcm  DIMENSION MWINDS(10)
      character*4 MWINDS(10)
Ctcm  DIMENSION MFILID(60)
      character*4 MFILID(60)
      DIMENSION JOPTIN(30)
      DIMENSION INFILE(6)
      DIMENSION JSTKPT(4)
      COMMON JSCRTC(16000000)
      character*4 jscrtc
      DIMENSION JSCPTR(46)
      DIMENSION LPRINT(9)
Ctcm  DIMENSION MUNVAR(10,6)
      character*4 MUNVAR(10,6)
      DIMENSION JINTSC(9)
      DIMENSION REALSC(12)
      CHARACTER*80 FNAME
      CHARACTER*24 MVERSN
C
C SET EQUIVALENCE FOR SCRATCH POINTERS
C
      EQUIVALENCE (JSCPTR( 1), KVBNM)
      EQUIVALENCE (JSCPTR( 2), KUNNM)
      EQUIVALENCE (JSCPTR( 3), KMULT)
      EQUIVALENCE (JSCPTR( 4), KADTV)
      EQUIVALENCE (JSCPTR( 5), KMOLW)
      EQUIVALENCE (JSCPTR(6), KMTSC)
      EQUIVALENCE (JSCPTR( 7), KPSNM)
      EQUIVALENCE (JSCPTR( 8), KPTNM)
      EQUIVALENCE (JSCPTR( 9), KPSXL)
      EQUIVALENCE (JSCPTR(10), KPSYL)
      EQUIVALENCE (JSCPTR(11), KPSTP)
      EQUIVALENCE (JSCPTR(12), KPSEV)
      EQUIVALENCE (JSCPTR(13), KPSEF)
      EQUIVALENCE (JSCPTR(14), KMTHN)
      EQUIVALENCE (JSCPTR(15), KMINV)
      EQUIVALENCE (JSCPTR(16), KMAXV)
      EQUIVALENCE (JSCPTR(17), KPRMP)
      EQUIVALENCE (JSCPTR(18), KPRMC)
      EQUIVALENCE (JSCPTR(19), KPRNM)
      EQUIVALENCE (JSCPTR(20), KPRMV)
      EQUIVALENCE (JSCPTR(22), KVMTN)
      EQUIVALENCE (JSCPTR(23), KVMNV)
      EQUIVALENCE (JSCPTR(24), KVMXV)
      EQUIVALENCE (JSCPTR(25), KVPRP)
      EQUIVALENCE (JSCPTR(26), KVPRC)
      EQUIVALENCE (JSCPTR(27), KVPNM)
      EQUIVALENCE (JSCPTR(28), KVPRV)
      EQUIVALENCE (JSCPTR(29), KPSSH)
      EQUIVALENCE (JSCPTR(30), KPSSD)
      EQUIVALENCE (JSCPTR(31), KPSST)
      EQUIVALENCE (JSCPTR(32), KPSSV)
      EQUIVALENCE (JSCPTR(33), KDFBK)
      EQUIVALENCE (JSCPTR(34), KRGTP)
      EQUIVALENCE (JSCPTR(35), KTPCN)
      EQUIVALENCE (JSCPTR(36), KTMPS)
      EQUIVALENCE (JSCPTR(38), KWNDU)
      EQUIVALENCE (JSCPTR(39), KWNDV)
      EQUIVALENCE (JSCPTR(40), KPGRD)
      EQUIVALENCE (JSCPTR(41), KPSXC)
      EQUIVALENCE (JSCPTR(42), KPSYC)
      EQUIVALENCE (JSCPTR(43), KPSZC)
      EQUIVALENCE (JSCPTR(44), KPSPH)
      EQUIVALENCE (JSCPTR(45), KPSFR)
      EQUIVALENCE (JSCPTR(46), KPSFX)
C
C SET EQUIVALENCE FOR CONTROL OPTIONS VECTOR
C
      EQUIVALENCE (JOPTIN( 1), NSPECS)
      EQUIVALENCE (JOPTIN( 2), NUSVAR)
      EQUIVALENCE (JOPTIN (3), NPTSRC)
      EQUIVALENCE (JOPTIN (4), NPTSRT)
      EQUIVALENCE (JOPTIN(5), NPARAM)
      EQUIVALENCE (JOPTIN( 7), IPTSRC)
      EQUIVALENCE (JOPTIN(19), NVPARM)
      EQUIVALENCE (JOPTIN(25), IDFBRK)
      EQUIVALENCE (JOPTIN(26), IRGTOP)
      EQUIVALENCE (JOPTIN(28), ITEMPS)
      EQUIVALENCE (JOPTIN(29), IMETSC)
      EQUIVALENCE (JOPTIN(30), IWINDS)
c   added, 1/22/90 - tcm
      EQUIVALENCE (INFILE(1), JOPTIN(25))
      EQUIVALENCE (JSTKPT(1), JSCPTR(29))
C
C SET EQUIVALENCE FOR PRINT FLAGS
C
      EQUIVALENCE (LPRINT(1), LINPTP)
      EQUIVALENCE (LPRINT(2), LPSEGP)
      EQUIVALENCE (LPRINT(3), LUNITP)
      EQUIVALENCE (LPRINT(4), LPSLTP)
      EQUIVALENCE (LPRINT(5), LPSLGP)
      EQUIVALENCE (LPRINT(6), LMTHDP)
      EQUIVALENCE (LPRINT(7), LPSRDP)
      EQUIVALENCE (LPRINT(8), LVMTHP)
      EQUIVALENCE (LPRINT(9), LPGRDP)
C
C SET EQUIVALENCES FOR INPUT FILES
C
c  removed, 1/22/90 - tcm
c     EQUIVALENCE (INFILE(1), IDFBRK)
c     EQUIVALENCE (INFILE(2), IRGTOP)
c     EQUIVALENCE (INFILE(4), ITEMPS)
c     EQUIVALENCE (INFILE(5), IMETSC)
c     EQUIVALENCE (INFILE(6), IWINDS)
C
C SET EQUIVALENCE FOR STACK PARAMETER POINTERS
C
c  removed, 1/22/90 - tcm
c     EQUIVALENCE (JSTKPT(1), KPSSH)
c     EQUIVALENCE (JSTKPT(2), KPSSD)
c     EQUIVALENCE (JSTKPT(3), KPSST)
c     EQUIVALENCE (JSTKPT(4), KPSSV)
C
C SET EQUIVALENCE FOR INTEGER SCALARS
C
      EQUIVALENCE (JINTSC(1), INCARD)
      EQUIVALENCE (JINTSC(2), IPRINT)
      EQUIVALENCE (JINTSC(3), IOUTFL)
      EQUIVALENCE (JINTSC(4), NZLOWR)
      EQUIVALENCE (JINTSC(5), NZUPPR)
      EQUIVALENCE (JINTSC(6), JBEGDT)
      EQUIVALENCE (JINTSC(7), JENDDT)
      EQUIVALENCE (JINTSC(8), JUTMZN)
      EQUIVALENCE (JINTSC(9), JMISSV)
C
C SET EQUIVALENCE FOR REAL SCALARS
C
      EQUIVALENCE (REALSC( 1), BEGTIM)
      EQUIVALENCE (REALSC( 2), ENDTIM)
      EQUIVALENCE (REALSC( 3), XUTMOR)
      EQUIVALENCE (REALSC( 4), YUTMOR)
      EQUIVALENCE (REALSC( 5), XREGOR)
      EQUIVALENCE (REALSC( 6), YREGOR)
      EQUIVALENCE (REALSC( 7), XCELLD)
      EQUIVALENCE (REALSC( 8), YCELLD)
      EQUIVALENCE (REALSC( 9), ZHTSUR)
      EQUIVALENCE (REALSC(10), ZMINLW)
      EQUIVALENCE (REALSC(11), ZMINUP)
      EQUIVALENCE (REALSC(12), RMISSV)
C
C SET CERTAIN VARIABLE VALUES
C
      DATA JFLAG /0/
      DATA INCARD /3/
      DATA IPRINT /4/
      DATA NAMLEN /10/
      DATA NIDLEN /60/
      DATA NSGMNT /1/
      DATA NOPTIN /30/
      DATA NINVAR /0/
      DATA NUNVAR /6/
      DATA NSCRTC /16000000/
      DATA NSCPTR /46/
      DATA RMISSV /-9.0/
      DATA JMISSV /-9/
      DATA JXSGOR /0/
      DATA JYSGOR /0/
      DATA NMETHD /1/
      DATA NVMETH /1/
      DATA NPRFHT /0/
      DATA NSTATS /0/
      DATA NMETSC /6/
      DATA NBLINE /0/
      DATA NINFIL /6/
      DATA LPRINT /9 * .FALSE./
      DATA IFILES /5/
C
C SET THE FILE NAME AND UNIT-ONLY VARIABLE NAMES
C
      DATA MFILNM /'P', 'T', 'S', 'O', 'U', 'R', 'C', 'E', ' ', ' '/
      DATA  MUNVAR             /'C','O','O','R','D',' ',' ',' ',' ',' ',
     &                          'H','E','I','G','H','T',' ',' ',' ',' ',
     &                          'D','I','A','M','E','T','E','R',' ',' ',
     &                          'S','T','A','C','K','T','E','M','P',' ',
     &                          'S','T','A','C','K','V','E','L',' ',' ',
     &                          'F','L','O','W','R','A','T','E',' ',' '/
C
C FILL IN INPUT FILE NAMES
C
      DATA MDIFBK /'D', 'I', 'F', 'F', 'B', 'R', 'E', 'A', 'K', ' '/
      DATA MREGTP /'R', 'E', 'G', 'I', 'O', 'N', 'T', 'O', 'P', ' '/
      DATA MTEMPS /'T', 'E', 'M', 'P', 'E', 'R', 'A', 'T', 'U', 'R'/
      DATA MMETSC /'M', 'E', 'T', 'S', 'C', 'A', 'L', 'A', 'R', 'S'/
      DATA MWINDS /'W', 'I', 'N', 'D', ' ', ' ', ' ', ' ', ' ', ' '/
C 
C   SET VERSION
C
      DATA MVERSN /'PTSRCE V1.11, 6/17/94   '/
C
C  RESET ERROR OPTION TABLE SO FIRST DIMENSION OF 0 IS OK
C
C     CALL ERRSET(187,256,-1,1,1,1)
C
C
C  SET PRINT WIDTH TO 132 COLUMNS - NOT NEEDED ON IBM
C
C     CALL ATTDEV(INTS(6), INTS(7), INTS(2), INTS(66))
C
C    OPEN STANDARD INPUT AND OUTPUT FILES
C
      OPEN(5)
      READ(5,'(20X,A)') FNAME
      OPEN (INCARD,FILE=FNAME,FORM='FORMATTED',STATUS='OLD')
      READ(5,'(20X,A)') FNAME
      OPEN (IPRINT,FILE=FNAME,FORM='FORMATTED')
C
C   WRITE VERSION NUMBER
C
      WRITE(IPRINT,'(1H1,A)') MVERSN
C
C
C READ THE CONTROL INFORMATION
C
      CALL CNTLRD(INCARD, IPRINT, NAMLEN, NIDLEN, NOPTIN, MFILNM,
     $            JBEGDT, JENDDT, BEGTIM, ENDTIM,
     $    MFILID, JOPTIN, JSCRTC, JFLAG)
      IF (JFLAG .LT. 0) GO TO 905
C
C SET THE OUTPUT FILE
C
      IOUTFL = IPTSRC
C
C SET THE LOGICAL PRINT VECTOR
C
      IF (JOPTIN( 8) .GT. 0) LINPTP = .TRUE.
      IF (JOPTIN( 9) .GT. 0) LPSEGP = .TRUE.
      IF (MOD(JOPTIN( 9),10) .GT. 0) LPGRDP = .TRUE.
      IF (JOPTIN(13) .GT. 0) LUNITP = .TRUE.
      IF (JOPTIN(14) .GT. 0) LPSLTP = .TRUE.
c  removed 3/5/90, tcm
c     IF (JOPTIN(15) .GT. 0) LPSLGP = .TRUE.
      IF (JOPTIN(16) .GT. 0) LMTHDP = .TRUE.
      IF (JOPTIN(17) .GT. 0) LPSRDP = .TRUE.
      IF (JOPTIN(21) .GT. 0) LVMTHP = .TRUE.
C
C WRITE OUTPUT HEADER INFORMATION
C
      WRITE (IPRINT, 2005) MFILNM, MFILID
C
C   OPEN BINARY OUTPUT FILE AND INPUT FILES
C   (ADDED 1/26/88, TCM)
C
      CALL OPENP(IFILES, IPTSRC, IDFBRK, IRGTOP, ITEMPS, IMETSC,
     $           IWINDS)
C
C IF WANTED, PRINT THE OPERATING PARAMETERS
C
      IF (.NOT.LINPTP) GO TO 210
      WRITE (IPRINT, 2010) NUSVAR
      WRITE (IPRINT, 2015) NPTSRC
      WRITE (IPRINT, 2020) NPTSRT
      WRITE (IPRINT, 2025) NPARAM
      WRITE (IPRINT, 2030) NVPARM
C
C PRINT THE FILES TO BE ACCESSED
C
      IF (IPTSRC .GT. 0) WRITE (IPRINT, 2040) IPTSRC
      IF (IDFBRK .GT. 0) THEN
        WRITE (IPRINT, 2045) IDFBRK
      ELSE 
        WRITE (IPRINT, 2046)
      ENDIF 
      IF (IRGTOP .GT. 0) THEN
        WRITE (IPRINT, 2050) IRGTOP
      ELSE
        WRITE (IPRINT, 2051)
      ENDIF
      IF (ITEMPS .GT. 0) WRITE (IPRINT, 2060) ITEMPS
      IF (IMETSC .GT. 0) WRITE (IPRINT, 2065) IMETSC
      IF (IWINDS .GT. 0) WRITE (IPRINT, 2070) IWINDS
C
C PRINT THE PRINT FLAG DESIGNATIONS
C
      IF (.NOT. LINPTP) WRITE (IPRINT, 2105)
      IF (LINPTP) WRITE (IPRINT, 2110)
      IF (.NOT. LPSEGP) WRITE (IPRINT, 2115)
      IF (LPSEGP) WRITE (IPRINT, 2120)
      IF (.NOT. LPGRDP) WRITE (IPRINT, 2116)
      IF (LPGRDP) WRITE (IPRINT, 2121)
      IF (.NOT. LUNITP) WRITE (IPRINT, 2125)
      IF (LUNITP) WRITE (IPRINT, 2130)
      IF (.NOT. LPSLTP) WRITE (IPRINT, 2135)
      IF (LPSLTP) WRITE (IPRINT, 2140)
c  removed 3/5/90, tcm
c     IF (.NOT. LPSLGP) WRITE (IPRINT, 2145)
c     IF (LPSLGP) WRITE (IPRINT, 2150)
      IF (.NOT. LMTHDP) WRITE (IPRINT, 2155)
      IF (LMTHDP) WRITE (IPRINT, 2160)
      IF (.NOT. LPSRDP) WRITE (IPRINT, 2165)
      IF (LPSRDP) WRITE (IPRINT, 2170)
      IF (.NOT. LVMTHP) WRITE (IPRINT, 2175)
      IF (LVMTHP) WRITE (IPRINT, 2180)
C
C PRINT THE DATES AND TIMES
C
      WRITE (IPRINT, 2205) JBEGDT, BEGTIM, JENDDT, ENDTIM
C
C CHECK FOR PRESENCE OF SPECIES NAMES
C
      IF (NSPECS .LE. 0) GO TO 910
      NWORDS = NAMLEN * NSPECS
      WRITE (IPRINT, 2210) NSPECS, (JSCRTC(I),I=1,NWORDS)
C
C READ THE REGION DEFINITION
C
  210 CALL REGNRD(INCARD, IPRINT, NXCELL, NYCELL, NZCELL, NZLOWR,
     $            NZUPPR, JUTMZN, XUTMOR, YUTMOR,
     $            XREGOR, YREGOR, XCELLD, YCELLD,
     $            ZHTSUR, ZMINLW, ZMINUP, JFLAG)
      IF (JFLAG .LT. 0) GO TO 915
C
C VERIFY THE EXISTENCE OF ONE VERTICAL LAYER
C
      IF (NZCELL .LT. 2) GO TO 920
C
C IF WANTED, PRINT THE REGION DEFINITION
C
      IF (.NOT. LINPTP) GO TO 310
      WRITE (IPRINT,2305) XUTMOR, YUTMOR, JUTMZN, XREGOR, YREGOR,
     $                    XCELLD, YCELLD, NXCELL, NYCELL
      IF (NZCELL .LE. 0) GO TO 310
      WRITE (IPRINT,2310) NZCELL,NZLOWR, NZUPPR, ZHTSUR, ZMINLW, ZMINUP
C
C CHECK FOR PRESENCE OF INPUT FILES AND SET SPECIES NAME SIZE
C
  310 IF (NINFIL .LE. 0) GO TO 410
      NWORDS = NAMLEN * NSPECS + 1
      NSCLFT = NSCRTC - NWORDS
C
C DIFFUSION BREAK
C
      IF (IDFBRK .GT. 0) CALL FILVER(IPRINT, IDFBRK, NAMLEN, NIDLEN,
     $     NSGMNT, NSPECS, NSCLFT, NXCELL, NYCELL, NZCELL,
     $     NZLOWR, NZUPPR, JBEGDT, JENDDT, JUTMZN,
     $     BEGTIM, ENDTIM, XUTMOR, YUTMOR, XREGOR,
     $     YREGOR, XCELLD, YCELLD, ZHTSUR, ZMINLW, ZMINUP,
     $     JXSGOR, JYSGOR, NXCELL, NYCELL, MDIFBK,
     $     JSCRTC(NWORDS), JSCRTC(NWORDS), JSCRTC(1), JFLAG)
      IF (JFLAG .LT. 0) GO TO 925
C
C REGION TOP
C
      IF (IRGTOP .GT. 0) CALL FILVER(IPRINT, IRGTOP, NAMLEN, NIDLEN,
     $     NSGMNT, NSPECS, NSCLFT, NXCELL, NYCELL, NZCELL,
     $     NZLOWR, NZUPPR, JBEGDT, JENDDT, JUTMZN,
     $     BEGTIM, ENDTIM, XUTMOR, YUTMOR, XREGOR,
     $     YREGOR, XCELLD, YCELLD, ZHTSUR, ZMINLW, ZMINUP,
     $     JXSGOR, JYSGOR, NXCELL, NYCELL, MREGTP,
     $     JSCRTC(NWORDS), JSCRTC(NWORDS), JSCRTC(1), JFLAG)
      IF (JFLAG .LT. 0) GO TO 930
C
C TEMPERATURE
C
      IF (ITEMPS .GT. 0) CALL FILVER(IPRINT, ITEMPS, NAMLEN, NIDLEN,
     $     NSGMNT, NSPECS, NSCLFT, NXCELL, NYCELL, NZCELL,
     $     NZLOWR, NZUPPR, JBEGDT, JENDDT, JUTMZN,
     $     BEGTIM, ENDTIM, XUTMOR, YUTMOR, XREGOR,
     $     YREGOR, XCELLD, YCELLD, ZHTSUR, ZMINLW, ZMINUP,
     $     JXSGOR, JYSGOR, NXCELL, NYCELL, MTEMPS,
     $     JSCRTC(NWORDS), JSCRTC(NWORDS), JSCRTC(1), JFLAG)
      IF (JFLAG .LT. 0) GO TO 940
C
C METEOROLOGICAL SCALARS
C
      IF (IMETSC .GT. 0) CALL FILVER(IPRINT, IMETSC, NAMLEN, NIDLEN,
     $     NSGMNT, NSPECS, NSCLFT, NXCELL, NYCELL, NZCELL,
     $     NZLOWR, NZUPPR, JBEGDT, JENDDT, JUTMZN,
     $     BEGTIM, ENDTIM, XUTMOR, YUTMOR, XREGOR,
     $     YREGOR, XCELLD, YCELLD, ZHTSUR, ZMINLW, ZMINUP,
     $     JXSGOR, JYSGOR, NXCELL, NYCELL, MMETSC,
     $     JSCRTC(NWORDS), JSCRTC(NWORDS), JSCRTC(1), JFLAG)
      IF (JFLAG .LT. 0) GO TO 945
C
C WIND
C
      IF (IWINDS .GT. 0) CALL FILVER(IPRINT, IWINDS, NAMLEN, NIDLEN,
     $     NSGMNT, NSPECS, NSCLFT, NXCELL, NYCELL, NZCELL,
     $     NZLOWR, NZUPPR, JBEGDT, JENDDT, JUTMZN,
     $     BEGTIM, ENDTIM, XUTMOR, YUTMOR, XREGOR,
     $     YREGOR, XCELLD, YCELLD, ZHTSUR, ZMINLW, ZMINUP,
     $     JXSGOR, JYSGOR, NXCELL, NYCELL, MWINDS,
     $     JSCRTC(NWORDS), JSCRTC(NWORDS), JSCRTC(1), JFLAG)
      IF (JFLAG .LT. 0) GO TO 950
C
C IF THERE IS TO BE AN OUTPUT FILE, WRITE ITS HEADER RECORDS
C
  410 IF (IPTSRC .LE. 0) GO TO 510
C
C FILE PARAMETERS (HEADER)
C
      CALL FLHDWR(IPRINT, IPTSRC, NAMLEN, NIDLEN, NSGMNT, NSPECS,
     $     JBEGDT, JENDDT, BEGTIM, ENDTIM, MFILNM, MFILID, JFLAG)
      IF (JFLAG .LT. 0) GO TO 955
C
C REGION DESCRIPTION
C
      CALL FLRGWR(IPRINT, IPTSRC, NXCELL, NYCELL, NZCELL, NZLOWR,
     $            NZUPPR, JUTMZN, XUTMOR, YUTMOR,
     $            XREGOR, YREGOR, XCELLD, YCELLD,
     $            ZHTSUR, ZMINLW, ZMINUP, JFLAG)
      IF (JFLAG .LT. 0) GO TO 960
C
C SEGMENTATION
C
      CALL FLSGWR(IPRINT, IPTSRC, NSGMNT, JXSGOR, JYSGOR,
     $     NXCELL, NYCELL, JFLAG)
      IF (JFLAG .LT. 0) GO TO 965
C
C SPECIES NAMES
C
      CALL FLSPWR(IPRINT, IPTSRC, NAMLEN, NSPECS, JSCRTC(1), JFLAG)
      IF (JFLAG .LT. 0) GO TO 970
C
C SET CURRENT SCRATCH LOCATION -- PARTITION SCRATCH
C
  510 NSCLFT = NSCRTC
      CALL SCRPRT(IPRINT, NAMLEN, NINVAR, NSPECS, NUSVAR, NUNVAR,
     $    NSTATS, NPTSRC, NPTSRT, NBLINE, NPTSRT, NMETHD, NPARAM,
     $     NVMETH, NVPARM, NPRFHT, NMETSC, NSCLFT, NSCPTR, NXCELL,
     $     NYCELL, NZCELL, NINFIL, INFILE, JSCRTC, JSCPTR, NVARBL,
     $     NUNITS, JFLAG)
      IF (JFLAG .LT. 0) GO TO 975
C
C SET POINTER TO NEXT AVAILABLE SCRATCH LOCATION
C
      KSPTR = NSCRTC - NSCLFT + 1
C
C PLACE UNIT-ONLY VARIABLES INTO THE VARIABLE NAMES
C
      NWORDS = (NUNITS - NUNVAR) * NAMLEN
      DO 525 I=1,NAMLEN
         JSCRTC(NWORDS + I) = MUNVAR(I,1)
         JSCRTC(NWORDS + NAMLEN +I) = MUNVAR(I,2)
         JSCRTC (NWORDS + 2*NAMLEN + I) = MUNVAR(I, 3)
         JSCRTC (NWORDS + 3*NAMLEN + I) = MUNVAR(I, 4)
         JSCRTC (NWORDS + 4*NAMLEN + I) = MUNVAR(I, 5)
         JSCRTC(NWORDS + 5*NAMLEN + I) = MUNVAR(I,6)
  525 CONTINUE
C
C CALL THE DATA PROCESSING ROUTINE
C
C   ADDED 10/22/86 (DMB) - RESET SO 0 DIMENSION NOT PASSED FOR MVPARM
C
      IF (NVPARM.EQ.0) NVPARM=1
C
      CALL PTSPRC(NAMLEN, NIDLEN, NVARBL, NSPECS, NUNITS, NPTSRC,
     $    NPTSRT,
     $    NPARAM, NVPARM, NMETSC, NSCLFT, NXCELL, NYCELL,
     $    NZCELL, INFILE, MFILNM, MFILID, LPRINT, JINTSC,
     $    JSCRTC(KSPTR), JSTKPT, JSCRTC(1), REALSC,
     $    JSCRTC(KMULT), JSCRTC(KADTV), JSCRTC(KMOLW), JSCRTC(KPSTP),
     $    JSCRTC(KPSXC), JSCRTC(KPSYC), JSCRTC(KPSZC), JSCRTC(KPSXL),
     $    JSCRTC(KPSYL),
     $    JSCRTC(KPSPH), JSCRTC(KPSFR), JSCRTC(KPRMV), JSCRTC(KVPRV),
     $    JSCRTC(KMTSC), JSCRTC(KVBNM), JSCRTC(KUNNM), JSCRTC(KPSNM),
     $    JSCRTC(KPTNM), JSCRTC(KPRNM), JSCRTC(KVPNM),
     $    JSCRTC(KMTHN), JSCRTC(KPRMP), JSCRTC(KPRMC), JSCRTC(KVMTN),
     $    JSCRTC(KVPRP), JSCRTC(KVPRC), JSCRTC(KPGRD),
     $    JSCRTC(KPSEV), JSCRTC(KPSEF), JSCRTC(KPSFX),
     $    JSCRTC(KMINV), JSCRTC(KMAXV), JSCRTC(KVMNV), JSCRTC(KVMXV),
     $    JSCRTC(KDFBK), JSCRTC(KRGTP), JSCRTC(KTMPS),
     $    JSCRTC(KWNDU), JSCRTC(KWNDV), JFLAG)
      IF (JFLAG .LT. 0) GO TO 980
C
C END OF PROCESSING -- SKIP TO TERMINATOR
C
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN CNTLRD
C
  905 WRITE(IPRINT, 2905) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN SPECIES COUNT
C
  910 WRITE(IPRINT, 2910) NSPECS
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN REGNRD
C
  915 WRITE(IPRINT, 2915) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN VERTICAL CELL COUNT
C
  920 WRITE (IPRINT, 2920) NZCELL
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FILVER FOR IDFBRK
C
  925 WRITE(IPRINT, 2925) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FILVER FOR IRGTOP
C
  930 WRITE(IPRINT,2930) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FILVER FOR ITEMPS
C
  940 WRITE(IPRINT,2940) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FILVER FOR IMETSC
C
  945 WRITE(IPRINT,2945) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FILVER FOR IWINDS
C
  950 WRITE(IPRINT,2950) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FLHDWR
C
  955 WRITE(IPRINT, 2955) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FLRGWR
C
  960 WRITE(IPRINT, 2960) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FLSGWR
C
  965 WRITE(IPRINT, 2965) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN FLSPWR
C
  970 WRITE(IPRINT, 2970) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN SCRPRT
C
  975 WRITE(IPRINT, 2975) JFLAG
      GO TO 1000
C
C ERROR MESSAGE FOR ERROR IN PTSPRC
C
  980 WRITE(IPRINT, 2980) JFLAG
      GO TO 1000
C
C TERMINATE PROCESSING
C
 1000 WRITE (IPRINT,2999)
      STOP
C
C FORMATS
C
 2000 FORMAT(/,'ER!  USAGE:  LOAD -IT PTSRCE infile outfile filnames')
 2005 FORMAT (1H1, 48HPROCESSING OF INPUT DATA FOR THE PREPARATION OF ,
     $        5HFILE , 10A1, //, 1X, 60A1, //)
 2010 FORMAT (36H NUMBER OF USER-DEFINED VARIABLES = ,I10)
 2015 FORMAT (27H NUMBER OF POINT SOURCES = , I10)
 2020 FORMAT (31H NUMBER OF POINT SOURCE TYPES = , I10)
 2025 FORMAT (31H NUMBER OF METHOD PARAMETERS = , I10)
 2030 FORMAT (40H NUMBER OF VERTICAL METHOD PARAMETERS = , I10)
 2040 FORMAT (45H PROGRAM OUTPUT WILL BE PLACED ON FILE NUMBER ,I10)
 2045 FORMAT (49H INPUT DATA FOR DIFFUSION BREAK WILL BE OBTAINED ,
     $        17HFROM FILE NUMBER , I10)
 2046 FORMAT (49H NO INPUT DATA FOR DIFFUSION BREAK IS PROVIDED.  ,/,
     $        44H DEFAULT VALUE OF 1000. METERS WILL BE USED.)
 2050 FORMAT (44H INPUT DATA FOR REGION TOP WILL BE OBTAINED ,
     $        17HFROM FILE NUMBER , I10)
 2051 FORMAT (44H NO INPUT DATA FOR REGION TOP IS PROVIDED.  ,/,
     $        44H DEFAULT VALUE OF 2000. METERS WILL BE USED.)
 2060 FORMAT (46H INPUT DATA FOR TEMPERATURES WILL BE OBTAINED ,
     $        17HFROM FILE NUMBER , I10)
 2065 FORMAT(47H INPUT DATA FOR METEOROLOGICAL SCALARS WILL BE ,
     $        26HOBTAINED FROM FILE NUMBER , I10)
 2070 FORMAT (39H INPUT DATA FOR WINDS WILL BE OBTAINED ,
     $        17HFROM FILE NUMBER , I10)
 2105 FORMAT (33H INPUT VALUES WILL NOT BE PRINTED)
 2110 FORMAT (29H INPUT VALUES WILL BE PRINTED)
 2115 FORMAT (43H OUTPUT VALUE WILL NOT BE PRINTED (TABULAR))
 2116 FORMAT (43H OUTPUT VALUE WILL NOT BE PRINTED (GRIDDED))
 2120 FORMAT (39H OUTPUT VALUE WILL BE PRINTED (TABULAR))
 2121 FORMAT (39H OUTPUT VALUE WILL BE PRINTED (GRIDDED))
 2125 FORMAT (31H UNIT TABLE WILL NOT BE PRINTED)
 2130 FORMAT (27H UNIT TABLE WILL BE PRINTED)
 2135 FORMAT (48H POINT SOURCE LOCATION TABLE WILL NOT BE PRINTED)
 2140 FORMAT (44H POINT SOURCE LOCATION TABLE WILL BE PRINTED)
 2145 FORMAT (47H POINT SOURCE LOCATION GRID WILL NOT BE PRINTED)
 2150 FORMAT (43H POINT SOURCE LOCATION GRID WILL BE PRINTED)
 2155 FORMAT (33H METHOD TABLE WILL NOT BE PRINTED)
 2160 FORMAT (29H METHOD TABLE WILL BE PRINTED)
 2165 FORMAT (46H POINT SOURCE INPUT VALUES WILL NOT BE PRINTED)
 2170 FORMAT (42H POINT SOURCE INPUT VALUES WILL BE PRINTED)
 2175 FORMAT (42H VERTICAL METHOD TABLE WILL NOT BE PRINTED)
 2180 FORMAT (38H VERTICAL METHOD TABLE WILL BE PRINTED)
 2205 FORMAT (24H BEGINNING DATE OF FILE , I10,
     $        24H BEGINNING TIME OF FILE , F10.2, //,
     $        21H ENDING DATE OF FILE , I10,
     $        21H ENDING TIME OF FILE , F10.2, /)
 2210 FORMAT (12H A TOTAL OF , I10, 26H SPECIES NAMES WERE READ  ,
     $        25HTHE SPECIES NAMES ARE -- , //, (1X, 10A1) )
 2305 FORMAT (1H1, 40X, 19HREGIONAL DEFINITION, ///,
     $        40H UTM ORIGIN X-COORDINATE                , F10.0,//,
     $        40H UTM ORIGIN Y-COORDINATE                , F10.0,//,
     $        40H UTM ORIGIN ZONE NUMBER                 , I10, //,
     $        40H REGION ORIGIN X-COORDINATE             , F10.0, //,
     $        40H REGION ORIGIN Y-COORDINATE             , F10.0, //,
     $        40H CELL LENGTH IN X-DIRECTION             , F10.2, //,
     $        40H CELL LENGTH IN Y-DIRECTION             , F10.2, //,
     $        40H NUMBER OF CELLS IN X-DIRECTION         , I10, //,
     $        40H NUMBER OF CELLS IN Y-DIRECTION         , I10, /)
 2310 FORMAT (40H NUMBER OF CELLS IN Z-DIRECTION         , I10, //,
     $        40H NUMBER OF CELLS IN LOWER VERTICAL LAYER, I10, //,
     $        40H NUMBER OF CELLS IN UPPER VERTICAL LAYER, I10, //,
     $        40H HEIGHT OF SURFACE LAYER                , F10.2, //,
     $        40H MINIMUM CELL HEIGHT IN LOWER LAYER     , F10.2, //,
     $        40H MINIMUM CELL HEIGHT IN UPPER LAYER     , F10.2, /)
 2905 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE CNTLRD, //)
 2910 FORMAT (1H1, 36H ****** SYSTEM OR INPUT ERROR ******,
     $        45H SUBROUTINE CNTLRD RETURNED SPECIES COUNT OF , I10, /,
     $        41H CONSULT PROGRAMMING STAFF FOR ASSISTANCE, //)
 2915 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE REGNRD, //)
 2920 FORMAT (1H1, 36H ****** SYSTEM OR INPUT ERROR ******,
     $        51HSUBROUTINE REGNRD RETURNED A VERTICAL CELL COUNT OF,
     $        I10, /, 41H CONSULT PROGRAMMING STAFF FOR ASSISTANCE , //)
 2925 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FILVER,
     $        20H FOR DIFFUSION BREAK, //)
 2930 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FILVER,
     $        15H FOR REGION TOP, //)
 2940 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FILVER,
     $        16H FOR TEMPERATURE, //)
 2945 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FILVER,
     $        27H FOR METEOROLOGICAL SCALARS, //)
 2950 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FILVER,
     $        10H FOR WINDS, //)
 2955 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FLHDWR, //)
 2960 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FLRGWR, //)
 2965 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FLSGWR, //)
 2970 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE FLSPWR, //)
 2975 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE SCRPRT, //)
 2980 FORMAT (26H ****** ERROR TRACE ******, 12H ERROR FLAG , I10,
     $        36H WAS RETURNED FROM SUBROUTINE PTSPRC, //)
 2999 FORMAT (1H1, 10HEND OF JOB)
      END
